#include "graphic_class.h"

int _time;
double weight = 8.0;

extern window W;

void sleep(void)
{
  rewind(stdin);
  getchar();
  return;
}

//  class MyList
MyList::MyList(void)
{
  initialize();
  return;
}

MyList::~MyList(void)
{
  remove();
  return;
}

void MyList::initialize(void)
{
  before = NULL;
  next   = NULL;
  return;
}

void MyList::remove(void)
{
  if (before != NULL)
    before->next = next;
  if (next != NULL)
    next->before = before;
  before = NULL;
  next   = NULL;
  return;
}

MyList* MyList::head(void)
{
  MyList* tp = this;
  while (tp->before != NULL)
    tp = tp->before;
  return tp;
}

MyList* MyList::tail(void)
{
  MyList* tp = this;
  while (tp->next != NULL)
    tp = tp->next;
  return tp;
}

MyList* MyList::insert(void)
{
  MyList* tp = new MyList();
  tp->before = this;
  tp->next   = next;
  next       = tp;
  return tp;
}

MyList* MyList::insert(MyList* tp)
{
  if (tp->before != NULL)
    tp->before->next = NULL;
  tp->before = this;
  if (next != NULL)
    next->before = tp->tail();
  tp->tail()->next = next;
  next = tp;

  return tp;
}

MyList* MyList::Insert(void)
{
  MyList* tp = new MyList();
  tp->next   = this;
  tp->before = before;
  before     = tp;
  return tp;
}

MyList* MyList::append(void)
{
  return push();
}

MyList* MyList::push(void)
{
  MyList* tp = tail();
  tp = tp->insert();
  return tp;
}

MyList* MyList::Push(void)
{
  MyList* tp = head();
  tp = tp->Insert();
  return tp;
}

//  class MyNode

MyNode::MyNode(void)
{
  initialize();
  return;
}

MyNode::MyNode(point p)
{
  initialize(p);
  return;
}

MyNode::~MyNode(void)
{
  remove();
  return;
}

void MyNode::initialize(void)
{
  before = NULL;
  next   = NULL;

  upper = false;
  center = false;
  return;
}

void MyNode::initialize(point p)
{
  initialize();
  input(p);

  return;
}

void MyNode::remove(void)
{
  if (before != NULL) {
    before->next = next;
  }
  if (next != NULL) {
    next->before = before;
  }
  next   = NULL;
  before = NULL;
  return;
}

MyNode* MyNode::head(void)
{
  MyNode* tp = this;
  while(tp->before != NULL)
    tp = tp->before;
  return tp;
}

MyNode* MyNode::tail(void)
{
  MyNode* tp = this;
  while(tp->next != NULL) {
    tp = tp->next;
  }
  return tp;
}

MyNode* MyNode::insert(void)
{
  MyNode* tp = new MyNode();
  tp->before = this;
  tp->next   = next;
  next       = tp;
  return tp;
}

MyNode* MyNode::insert(point p)
{
  MyNode* tp = insert();
  tp->input(p);
  return tp;
}

MyNode* MyNode::insert(MyNode* tp)
{
  if (tp->before != NULL)
    tp->before->next = NULL;
  tp->before = this;
  if (next != NULL)
    next->before = tp->tail();
  tp->tail()->next = next;
  next = tp;

  return tp;
}

MyNode* MyNode::Insert(void)
{
  MyNode* tp = new MyNode();
  tp->before = before;
  tp->next   = this;
  before     = tp;
  return tp;
}

MyNode* MyNode::Insert(point p)
{
  MyNode* tp = Insert();
  tp->input(p);
  return tp;
}

MyNode* MyNode::Insert(MyNode* X)
{
  MyNode* T;

  T = X->tail();
  before->next = X;
  X->before = before;
  before = T;
  T->next = this;
  return T;
}

MyNode* MyNode::append(void)
{
  return push();
}

MyNode* MyNode::append(point p)
{
  return push(p);
}

MyNode* MyNode::append(MyNode* t)
{
  return push(t);
}

MyNode* MyNode::push(void)
{
  MyNode* tp = tail();
  return tp->insert();
}

MyNode* MyNode::push(point p)
{
  MyNode* tp = push();
  tp->input(p);
  return tp;
}

MyNode* MyNode::push(MyNode* t)
{
  MyNode* tp = tail();
  return tp->insert(t);
}

MyNode* MyNode::Push(void)
{
  MyNode* tp = head();
  return tp->Insert();
}

MyNode* MyNode:: Push(point p)
{
  MyNode* tp = Push();
  tp->input(p);
  return tp;
}

MyNode* MyNode::search(point p)
{
  if (node == p)
    return this;
  if (next != NULL)
    return next->search(p);
  return NULL;
}

MyNode* MyNode::Search(point p)
{
  if (node == p)
    return this;
  if (before != NULL)
    return before->Search(p);
  return NULL;
}

void MyNode::input(point p)
{
  node = p;
}

point MyNode::value(void)
{
  return node;
}

point MyNode::Before(void)
{
  return before->node;
}

point MyNode::Next(void)
{
  return next->node;
}

point MyNode::first(void)
{
  MyNode* tp;
  tp = head();
  return tp->value();
}

point MyNode::last(void)
{
  MyNode* tp;
  tp = tail();
  return tp->value();
}

// class D3Node

D3MyNode::D3MyNode(void)
{
  initialize();
  return;
}

D3MyNode::D3MyNode(d3_point p)
{
  initialize(p);
  return;
}

D3MyNode::D3MyNode(MyNode* master, double z = 0.0)
{
  initialize(master, z);
  return;
}

D3MyNode::~D3MyNode(void)
{
  remove();
  return;
}

void D3MyNode::initialize(void)
{
  node   = d3_point(0.0, 0.0, 0.0);
  master = NULL;
  before = NULL;
  next   = NULL;
  in_knot = false;
  return;
}

void D3MyNode::initialize(d3_point p)
{
  initialize();
  node = p;
  return;
}

void D3MyNode::initialize(MyNode* master, double z = 0.0)
{
  initialize();
  node = d3_point(master->node.xcoord(), master->node.ycoord(), z);
  this->master = master;
  return;
}

void D3MyNode::remove(void)
{
  if (this->before != NULL)
   this->before->next = next;
  if (this->next != NULL)
    this->next->before = before;
  before = NULL;
  next = NULL;

  return;
}

D3MyNode* D3MyNode::head(void)
{
  if (before == NULL)
    return this;
  else
    return before->head();
}

D3MyNode* D3MyNode::tail(void)
{
  if (next == NULL)
    return this;
  else
    return next->tail();
}

D3MyNode* D3MyNode::insert(d3_point p)
{
  D3MyNode* tp;

  tp = new D3MyNode(p);
  tp->before = this;
  tp->next = next;
  if (next != NULL)
    next->before = tp;
  next = tp;

  return tp;
}

D3MyNode* D3MyNode::insert(MyNode* master, double z = 0.0)
{
  D3MyNode* tp;

  tp = new D3MyNode(master, z);
  tp->before = this;
  tp->next = next;
  if (next != NULL)
    next->before = tp;
  next = tp;

  return tp;
}

D3MyNode* D3MyNode::insert(D3MyNode* tp)
{
  if (tp->before != NULL)
    tp->before->next = NULL;
  tp->before = this;
  if (next != NULL)
    next->before = tp->tail();
  tp->tail()->next = next;
  next = tp;
  return next;
}

D3MyNode* D3MyNode::append(d3_point p)
{
  return tail()->insert(p);
}

D3MyNode* D3MyNode::append(MyNode* master, double z = 0.0)
{
  return tail()->insert(master, z);
}

D3MyNode* D3MyNode::append(D3MyNode* tp)
{
  return tail()->insert(tp);
}

D3MyNode* D3MyNode::push(d3_point p)
{
  return append(p);
}

D3MyNode* D3MyNode::push(MyNode* master, double z = 0.0)
{
  return append(master, z);
}

D3MyNode* D3MyNode::push(D3MyNode* tp)
{
  return append(tp);
}

D3MyNode* D3MyNode::convert(MyNode* master, double z = 0.0)
{
  D3MyNode* root;
  MyNode* tp;

  tp = master->next;
  root = new D3MyNode(master, z);
  while (tp != NULL) {
    root->append(tp, z);
    tp = tp->next;
  }
  return root;
}

//  class MyArc

MyArc::MyArc(void)
{
  initialize();
  return;
}

MyArc::MyArc(MyNode* alpha, MyNode* beta)
{
  initialize(alpha, beta);
  return;
}

MyArc::~MyArc(void)
{
  remove();
  return;
}

void MyArc::initialize(void)
{
  initialize(NULL, NULL);
  return;
}

void MyArc::initialize(MyNode* alpha, MyNode* beta)
{
  before = NULL;
  next   = NULL;
  input(alpha, beta);
  return;
}

void MyArc::remove(void)
{
  if (before != NULL)
    before->next = next;
  if (next != NULL)
    next->before = before;
  before = NULL;
  next   = NULL;
  return;
}

MyArc* MyArc::head(void)
{
  MyArc* tp = this;
  while (tp->before != NULL)
    tp = tp->before;
  return tp;
}

MyArc* MyArc::tail(void)
{
  MyArc* tp = this;
  while (tp->next != NULL)
    tp = tp->next;
  return tp;
}

MyArc* MyArc::insert(void)
{
  return insert(NULL, NULL);
}

MyArc* MyArc::insert(MyNode* alpha, MyNode* beta)
{
  MyArc* tp  = new MyArc(alpha, beta);
  tp->before = this;
  tp->next   = next;
  next       = tp;
  return tp;
}

MyArc* MyArc::insert(MyArc* time)
{
  MyArc* tend;

  tend = time->tail();
  tend->next = next;
  if (next != NULL) {
    next->before = tend;
  }
  while (time->before != NULL) {
    time = time->before;
  }
  next = time;
  time->before = this;
  return time;
}

MyArc* MyArc::Insert(void)
{
  return Insert(NULL, NULL);
}

MyArc* MyArc::Insert(MyNode* alpha, MyNode* beta)
{
  MyArc* tp  = new MyArc(alpha, beta);
  tp->before = before;
  tp->next   = this;
  before     = tp;
  return tp;
}

MyArc* MyArc::append(void)
{
  return push();
}

MyArc* MyArc::append(MyNode* alpha, MyNode* beta)
{
  return push(alpha, beta);
}

MyArc* MyArc::append(MyArc* item)
{
  return push(item);
}

MyArc* MyArc::push(void)
{
  return push(NULL, NULL);
}

MyArc* MyArc::push(MyNode* alpha, MyNode* beta)
{
  MyArc* tp = tail();
  return tp->insert(alpha, beta);
}

MyArc* MyArc::push(MyArc* item)
{
  MyArc* tp = tail();
  return tp->insert(item);
}

MyArc* MyArc::Push(void)
{
  return Push(NULL, NULL);
}

MyArc* MyArc::Push(MyNode* alpha, MyNode* beta)
{
  MyArc* tp = head();
  return tp->Insert(alpha, beta);
}

MyArc* MyArc::search(MyNode* x)
{
  MyArc* tp = this;
  while (tp != NULL){
    if (tp->from == x || tp->to == x)
      return tp;
    tp = tp->next;
  }
  return NULL;
}

MyArc* MyArc::search(segment s)
{
  MyArc* tp = this;
  while (tp != NULL){
    if (tp->arc == s)
      return tp;
    tp = tp->next;
  }
  return NULL;
}

MyArc* MyArc::search(MyNode* alpha, MyNode* beta)
{
  MyArc* tp = this;
  while (tp != NULL) {
    if ((tp->from == alpha && tp->to == beta) || (tp->from == beta && tp->to == alpha))
      return tp;
    tp = tp->next;
  }
  return NULL;
}

MyArc* MyArc::Search(MyNode* x)
{
  MyArc* tp = this;
  while (tp != NULL) {
    if (tp->from == x || tp->to == x)
      return tp;
    tp = tp->before;
  }
  return NULL;
}

MyArc* MyArc::Search(segment s)
{
  MyArc* tp = this;
  while (tp != NULL) {
    if (tp->arc == s)
      return tp;
    tp = tp->before;
  }
  return NULL;
}

MyArc* MyArc::Search(MyNode* alpha, MyNode* beta)
{
  MyArc* tp = this;
  while (tp != NULL) {
    if ((tp->from == alpha && tp->to == beta) || (tp->from == beta && tp->to == alpha))
      return tp;
    tp = tp->before;
  }
  return NULL;
}

bool MyArc::is_cross(point p)
{
  return arc.contains(p);
}

bool MyArc::is_cross(MyNode* x)
{
  return is_cross(x->node);
}

bool MyArc::is_cross(segment s)
{
  return arc.intersection(s);
}

bool MyArc::is_cross(MyNode* alpha, MyNode* beta)
{
  return is_cross(segment(alpha->node, beta->node));
}

bool MyArc::is_cross(MyArc* ap)
{
  return is_cross(ap->arc);
}

void MyArc::input(MyNode* alpha, MyNode* beta)
{
  arc  = segment(alpha->node, beta->node);
  from = alpha;
  to   = beta;
  return;
}

segment MyArc::value(void)
{
  return arc;
}

segment MyArc::Before(void)
{
  return before->arc;
}

segment MyArc::Next(void)
{
  return next->arc;
}

segment MyArc::first(void)
{
  MyArc* tp;
  tp = head();
  return tp->arc;
}

segment MyArc::last(void)
{
  MyArc* tp;
  tp = tail();
  return tp->arc;
}

MyNode* MyArc::From(void)
{
  return from;
}

MyNode* MyArc::To(void)
{
  return to;
}

// class D3MyArc

D3MyArc::D3MyArc(D3MyNode* f, D3MyNode* t)
{
  initialize(f, t);
}

D3MyArc::~D3MyArc(void)
{
  remove();
}

void D3MyArc::initialize(void)
{
  from   = NULL;
  to     = NULL;
  before = NULL;
  next   = NULL;
  in_knot = false;

  return;
}

void D3MyArc::initialize(D3MyNode* f, D3MyNode* t)
{
  initialize();
  input(f, t);
  return;
}

void D3MyArc::remove(void)
{
  if (before != NULL)
    before->next = next;
  if (next   != NULL)
    next->before = before;
  before = NULL;
  next = NULL;

  return;
}

void D3MyArc::input(D3MyNode* f, D3MyNode* t)
{
  from = f;
  to = t;

  arc = d3_segment(f->node, t->node);

  return;
}

D3MyArc* D3MyArc::head(void)
{
  if (before == NULL)
    return this;
  else
    return before->head();
}

D3MyArc* D3MyArc::tail(void)
{
  if (next == NULL)
    return this;
  else
    return next->tail();
}

D3MyArc* D3MyArc::insert(D3MyNode* f, D3MyNode* t)
{
  D3MyArc* tp;
  tp = new D3MyArc(f, t);

  if (next != NULL)
    next->before = tp;
  tp->next = next;
  tp->before = this;
  next = tp;

  return tp;
}

D3MyArc* D3MyArc::insert(D3MyArc* tp)
{
  if (next != NULL)
    next->before = tp->tail();
  tp->tail()->next = next;
  if (tp->before != NULL)
    tp->before->next = NULL;
  tp->before = this;
  next = tp;

  return tp;
}

D3MyArc* D3MyArc::append(D3MyNode* f, D3MyNode* t)
{
  return tail()->insert(f, t);
}

D3MyArc* D3MyArc::append(D3MyArc* tp)
{
  return tail()->insert(tp);
}

D3MyArc* D3MyArc::push(D3MyNode* f, D3MyNode* t)
{
  return append(f, t);
}

D3MyArc* D3MyArc::push(D3MyArc* tp)
{
  return append(tp);
}

// class Cross_point

Cross_point::Cross_point(void)
{
  initialize('a', NULL, NULL);
  return;
}

Cross_point::Cross_point(MyArc* alpha, MyArc* beta)
{
  initialize('a', alpha, beta);
  return;
}

Cross_point::Cross_point(char f, MyArc* alpha, MyArc* beta)
{
  initialize('a', alpha, beta);
  return;
}

Cross_point::~Cross_point(void)
{
  remove();
  return;
}

void Cross_point::initialize(void)
{
  initialize('a', NULL, NULL);
  return;
}

void Cross_point::initialize(MyArc* alpha, MyArc* beta)
{
  initialize('a', alpha, beta);
  return;
}

void Cross_point::initialize(char f, MyArc* alpha, MyArc* beta)
{
  input(f, alpha, beta);
  before = NULL;
  next = NULL;
  return;
}

void Cross_point::remove(void)
{
  if (before != NULL)
    before->next = next;
  if (next != NULL)
    next->before = before;
  before = NULL;
  next   = NULL;
  return;
}

Cross_point* Cross_point::head(void)
{
  Cross_point* tp = this;
  while (tp->before != NULL)
    tp = tp->before;
  return tp;
}

Cross_point* Cross_point::tail(void)
{
  Cross_point* tp = this;
  while (tp->next != NULL)
    tp = tp->next;
  return tp;
}

Cross_point* Cross_point::insert(void)
{
  return insert('a', NULL, NULL);
}


Cross_point* Cross_point::insert(MyArc* alpha, MyArc* beta)
{
  return insert('a', alpha, beta);
}

Cross_point* Cross_point::insert(char f, MyArc* alpha, MyArc* beta)
{
  Cross_point* tp = new Cross_point(f, alpha, beta);
  tp->before      = this;
  tp->next        = next;
  next            = tp;
  return tp;
}

Cross_point* Cross_point::Insert(void)
{
  return Insert('a', NULL, NULL);
}

Cross_point* Cross_point::Insert(MyArc* alpha, MyArc* beta)
{
  return Insert('a', alpha, beta);
}

Cross_point* Cross_point:: Insert(char f, MyArc* alpha, MyArc* beta)
{
  Cross_point* tp = new Cross_point(f, alpha, beta);
  tp->before      = before;
  tp->next        = this;
  before          = tp;
  return tp;
}

Cross_point* Cross_point::append(void)
{
  return push('a', NULL, NULL);
}

Cross_point* Cross_point::append(MyArc* alpha, MyArc* beta)
{
  return push('a', alpha, beta);
}

Cross_point* Cross_point::append(char f, MyArc* alpha, MyArc* beta)
{
  return push(f, alpha, beta);
}

Cross_point* Cross_point::push(void)
{
  return push('a', NULL, NULL);
}

Cross_point* Cross_point::push(MyArc* alpha, MyArc* beta)
{
  return push('a', alpha, beta);
}

Cross_point* Cross_point::push(char f, MyArc* alpha, MyArc* beta)
{
  Cross_point* tp = tail();
  return tp->insert(f, alpha, beta);
}

Cross_point* Cross_point::Push(void)
{
  return Push('a', NULL, NULL);
}

Cross_point* Cross_point::Push(MyArc* alpha, MyArc* beta)
{
  return Push('a', alpha, beta);
}

Cross_point* Cross_point::Push(char f, MyArc* alpha, MyArc* beta)
{
  Cross_point* tp = head();
  return tp->Insert(f, alpha, beta);
}

void Cross_point::input(char f)
{
  flag = f;
  return;
}

void Cross_point::input(MyArc* alpha, MyArc* beta)
{
  a = alpha;
  b = beta;
  (a->arc).intersection(b->arc, x);
  return;
}

void Cross_point::input(char f, MyArc* alpha, MyArc* beta)
{
  input(f);
  input(alpha, beta);
  return;
}

point Cross_point::value(void)
{
  return x;
}

point Cross_point::Before(void)
{
  return before->x;
}

point Cross_point::Next(void)
{
  return next->x;
}

point Cross_point::first(void)
{
  Cross_point* tp;
  tp = head();
  return tp->x;
}

point Cross_point::last(void)
{
  Cross_point* tp;
  tp = tail();
  return tp->x;
}

char Cross_point::Flag(void)
{
  return flag;
}

bool Cross_point::is_upper(point f, point t)
{
  MyNode* from;
  MyNode* to;

  if (flag == 'a') {
    from = a->from->Search(f);
    to   = a->to->search(t);
    if (from != NULL && to != NULL)
      return true;
  } else {
    from = b->from->Search(f);
    to   = b->to->search(t);
    if (from != NULL && to != NULL)
      return true;
  }
  return false;
}

bool Cross_point::is_downner(point f, point t)
{
  MyNode* from;
  MyNode* to;

  if (flag == 'a') {
    from = b->from->Search(f);
    to   = b->to->search(t);
    if (from != NULL && to != NULL)
      return true;
  } else {
    from = a->from->Search(f);
    to   = a->from->search(t);
    if (from != NULL && to != NULL)
      return true;
  }
  return false;
}

// class Time_arc

Time_arc::Time_arc(void)
{
  initialize();
  return;
}

Time_arc::Time_arc(MyArc* time)
{
  initialize(time);
  return;
}

Time_arc::~Time_arc(void)
{
  remove();
  return;
}

void Time_arc::initialize(void)
{
  X = NULL;
  N = NULL;
  M = NULL;
  return;
}

void Time_arc::initialize(MyArc* time)
{
  initialize();
  M = time;
  s = time->arc;
  return;
}

void Time_arc::remove(void)
{
  clean();
  return;
}

void Time_arc::clean(void)
{
  if (X != NULL) {
    while (X->next != NULL) {
      delete X->next;
    }
    delete X;
  }
  /*
  if (N != NULL) {
    while (N->next != NULL) {
      delete N->next;
    }
    delete N;
  }
  if (M != NULL) {
    while (M->next != NULL) {
      delete M->next;
    }
    delete M;
  }
  */
  initialize();
  return;
}

void Time_arc::clean(MyArc* time)
{
  clean();
  initialize(time);
  return;
}

MyNode* Time_arc::remove_from_X(MyNode* T)
{
  if (T != NULL) {
    if (T == X) {
      if (T->next == NULL) {
	X = NULL;
	return T;
      } else {
	X = T->next;
      }
    }
    if (T->before != NULL) {
      (T->before)->next = T->next;
    }
    if(T->next != NULL){
      (T->next)->before = T->before;
    }
    T->before = NULL;
    T->next   = NULL;
  }
  return T;
}

void Time_arc::sort(void)
{
  point from;
  MyNode* Time = NULL;
  MyNode* t;
  MyNode* neerist;

  double da, db;

  from = (M->from)->node;

  if (X != NULL) {
    if (X->next != NULL) {
      t = X;
      while (X != NULL) {
	neerist = X;
	t = X->next;
	while (t != NULL) {
	  da = from.distance(t->node);
	  db = from.distance(neerist->node);
	  if (da*da < db*db) {
	    neerist = t;
	  }
	  t = t->next;
	}
	remove_from_X(neerist);
	if (Time == NULL) {
	  Time = neerist;
	} else {
	  if (neerist->node != Time->tail()->node)
	    Time->append(neerist);
	}
      }
      X = Time;
    }
  }
  return;
}

void Time_arc::insert(point p)
{
  if (X == NULL) {
    X = new MyNode(p);
  } else {
    X->append(p);
  }
  return;
}

void Time_arc::insert(MyArc* a, MyArc* b)
{
  point p;
  if (a != NULL && b != NULL) {
    (a->arc).intersection(b->arc, p);
    insert(p);
  }
  return;
}

MyNode* Time_arc::get_ancor(void)
{
  MyNode* Time;
  point p;

  sort();
  if (X != NULL) {
    if (X->next != NULL) {
      Time = X;
      while (Time->next != NULL) {
	p = point(((Time->node).xcoord() + ((Time->next)->node).xcoord()) / 2.0,
		  ((Time->node).ycoord() + ((Time->next)->node).ycoord()) / 2.0);
	if (N == NULL) {
	  N = new MyNode(p);
	  N->center = true;
	} else {
	  N->append(p);
	  N->tail()->center = true;
	}
	Time = Time->next;
      }
      return N;
    }
  }
  //  sleep();
  return NULL;
}
 
// MyGraph

MyGraph::MyGraph(void)
{
  initialize();
  return;
}

MyGraph::MyGraph(list<point>* l)
{
  initialize(l);
  return;
}

MyGraph::MyGraph(list<point> l)
{
  initialize(l);
  return;
}

MyGraph::MyGraph(MyNode* m)
{
  initialize(m);
  return;
}

MyGraph::MyGraph(MyArc* m)
{
  initialize(m);
  return;
}

MyGraph::~MyGraph(void)
{
  remove();
  return;
}

void MyGraph::initialize(void)
{
  nodes       = NULL;
  arcs        = NULL;
  space_nodes = NULL;
  space_arcs  = NULL;
  return;
}
void MyGraph::initialize(list<point>* l)
{
  point t;

  initialize();
  // Under woeking...
  t = l->Pop();
  nodes  = new MyNode(t);
  space_nodes = new MyNode(t);
  while(l->empty() != true) {
    t = l->Pop();
    nodes->append(t);
    space_nodes->append(t);
  }
  get_arcs();
  return;
}
void MyGraph::initialize(list<point> l)
{
  point t;

  initialize();
  t = l.pop();
  nodes       = new MyNode(t);
  space_nodes = new MyNode(t);
  while(l.empty() != true) {
    t = l.pop();
    nodes->append(t);
    space_nodes->append(t);
  }
  get_arcs();
  return;
}

void MyGraph::initialize(MyNode* m)
{
  MyNode* tp;

  initialize();
  nodes       = new MyNode(m->node);
  space_nodes = new MyNode(m->node);
  tp = m->next;
  while (tp != NULL) {
    nodes->append(tp->node);
    space_nodes->append(tp->node);
    tp = tp->next;
  }
  get_arcs();
  return;
}

// Use this!!!

void MyGraph::initialize(MyArc* a)
{
  MyNode* tp;
  MyNode* pp;

  MyArc*  ap;
  MyArc*  tap;

  initialize();

  space_nodes = new MyNode(a->from->node);
  space_nodes->append(a->to->node);

  ap = a->next;
  while (ap->next != NULL) {
    tp = space_nodes->append(ap->to->node);
    ap = ap->next;
  }

  space_arcs = new MyArc(space_nodes, space_nodes->next);
  pp = space_nodes->next;
  while (pp->next != NULL) {
    space_arcs->append(pp, pp->next);
    pp = pp->next;
  }
  space_arcs->append(pp, space_nodes);

  tp = space_nodes;
  while (tp != NULL) {
    pp = tp->next;
    while (pp != NULL) {
      if (pp->node == tp->node) {
	ap = space_arcs;
	while (ap != NULL) {
	  if (ap->from == pp) {
	    ap->from = tp;
	  }
	  if (ap->to == pp) {
	    ap->to = tp;
	  }
	  ap = ap->next;
	}
	delete pp;
	break;
      }
      pp = pp->next;
    }
    tp = tp->next;
  }

  return;
}

/*
void MyGraph::initialize(MyArc* a)
{
  MyNode* tp;
  MyArc*  tap;
  MyNode* f;
  MyNode* t;

  f = nodes = new MyNode(a->from->node);
  t = nodes->append(a->to->node);
  arcs = new MyArc(f, t);
  f = space_nodes = new MyNode(a->from->node);
  t = space_nodes->append(a->to->node);
  space_arcs = new MyArc(f, t);

  tap = a->next;
  while (tap != NULL) {
    f = NULL;
    t = NULL;
    tp = nodes;
    while (tp != NULL) {
      if (tp->node == tap->from->node) {
	f = tp;
      }
      if (tp->node == tap->to->node) {
	t = tp;
      }
      if (f != NULL && t != NULL)
	break;
      tp = tp->next;
    }
    if (f == NULL)
      f = nodes->append(tap->from->node);
    if (t == NULL)
      t = nodes->append(tap->to->node);
    arcs->append(f, t);
    f = NULL;
    t = NULL;
    tp = space_nodes;
    while (tp != NULL) {
      if (tp->node == tap->from->node) {
	f = tp;
      }
      if (tp->node == tap->to->node) {
	t = tp;
      }
      if (f != NULL && t != NULL)
	break;
      tp = tp->next;
    }
    if (f == NULL)
      f = space_nodes->append(tap->from->node);
    if (t == NULL)
      t = space_nodes->append(tap->to->node);
    if (f != NULL && t != NULL)
      space_arcs->append(f, t);
    tap = tap->next;
  }
  return;
}
*/

MyNode* MyGraph::get_space_node(MyNode* t)
{
  MyNode* tp;

  tp = space_nodes;
  while (tp->node != t->node && tp != NULL) {
    tp = tp->next;
  }
  return tp;
}

void MyGraph::remove(void)
{
  return;
}

void MyGraph::add_node(MyNode* xp, point p)
{
  xp->insert(p);
  return;
}

void MyGraph::add_node(MyNode* xp, list<point>* l)
{
  /*
  point p;
  MyArc* ap;

  if (is_include(xp) != false) {
    ap = get_arc(xp);
    delete ap;
    while (l->empty == false) {
      p = l->Pop();
      xp->insert(p);
      xp = xp->next;
    }
  }
  */
  return;
}

void MyGraph::add_node(MyNode* xp, list<point> l)
{
  /*
  point p;
  MyArc ap;

  if (is_include(xp) != false) {
    ap = get_arc(segment(xp->node, xp->next->node));
    ap->remove();
    delete ap;
    while (l.empty() == false) {
      p = l.Pop();
      xp->insert(p);
      xp = xp->next;
    }
  }
  */
  return;
}

void MyGraph::add_node(MyNode* xp, MyNode* m)
{
  MyNode* tp;
  MyArc*  ap;

  if (is_include(xp) != false) {
    ap = get_arc(xp);
    delete ap;

    tp = m;
    while (tp != NULL) {
      xp->insert(tp->node);
      tp = tp->next;
      xp = xp->next;
    }
  }
  return;
}

void MyGraph::add_space(point p)
{
  space_nodes->append(p);
  return;
}

void MyGraph::add_space(list<point>* l)
{
  point p;

  while (l->empty() != true) {
    p = l->Pop();
    space_nodes->append(p);
  }
  return;
}

void MyGraph::add_space(list<point> l)
{
  point p;

  while (l.empty() != true) {
    p = l.Pop();
    space_nodes->append(p);
  }
  return;
}

void MyGraph::add_space(MyNode* m)
{
  MyNode* tp;
  
  tp = m;
  while (tp != NULL) {
    space_nodes->append(tp->node);
    tp = tp->next;
  }
  return;
}

bool MyGraph::is_include(point p)
{
  MyNode* tp;
  return false;
}

bool MyGraph::is_include(MyNode* p)
{
  MyNode* tp;
  return false;
}

bool MyGraph::is_in(point p)
{
  MyNode* tp;

  tp = space_nodes;
  while (tp != NULL) {
    if (tp->node == p)
      return true;
    tp = tp->next;
  }
  return false;
}

bool MyGraph::is_in(MyNode* p)
{
  MyNode* tp;

  tp = space_nodes;
  while (tp != NULL) {
    if (tp == p) {
      return true;
    }
    tp = tp->next;
  }
  return false;
}

bool MyGraph::is_in(MyNode p)
{
  MyNode* tp;

  tp = space_nodes;
  while (tp != NULL) {
    if (tp->node == p.node) {
      return true;
    }
    tp = tp->next;
  }
  return false;
}

bool MyGraph::is_in(segment s)
{
  MyArc* ap;

  ap = space_arcs;
  while (ap != NULL) {
    if (ap->arc == s|| ap->arc == s.reverse()) {
      return true;
    }
    ap = ap->next;
  }
  return false;
}

bool MyGraph::is_in(MyArc* s)
{
  MyArc* ap;

  ap = space_arcs;
  while (ap != NULL) {
    if ((ap->from->node == s->from->node && ap->to->node == s->to->node) ||
	(ap->from->node == s->to->node && ap->to->node == s->from->node)) {
      return true;
    }
    ap = ap->next;
  }
  return false;
}

bool MyGraph::is_in(MyArc s)
{
  MyArc* ap;

  ap = space_arcs;
  while (ap != NULL) {
    if ((ap->from == s.from && ap->to == s.to) ||
	(ap->from == s.to && ap->to == s.from)) {
      return true;
    }
    ap = ap->next;
  }
  return false;
}

bool MyGraph::is_cross(MyNode* a, MyNode* b)
{
  return (is_cross(segment(a->node, b->node)));
}

bool MyGraph::is_cross(MyNode a, MyNode b)
{
  return (is_cross(segment(a.node, b.node)));
}

bool MyGraph::is_cross(segment s)
{
  MyArc* tap;

  tap = space_arcs;
  // cout << s << endl;
  //  ::W.clear();
  //  ::W.set_line_width(1);
  //  ::W.set_color(color(0x00, 0x00, 0x00));
  //  ::W.draw_segment(s);
  //  ::W.set_line_width(2);
  while (tap != NULL) {
    if (tap->from->node == s.start() && tap->to->node == s.end()) {
      //::W.clear();
      //::W.set_line_width(2);
      //      ::W.set_color(color(0xFF, 0x00, 0x00));
      //      ::W.draw_segment(tap->arc);
      //      ::W.set_line_width(1);
      //      ::W.set_color(color(0x00, 0x00, 0xFF));
      //      ::W.draw_segment(s);
      //::W.read_mouse();
      return true;
    }
    if (tap->from->node == s.end() && tap->to->node == s.start()) {
      //::W.clear();
      //::W.set_line_width(2);
      //      ::W.set_color(color(0xFF, 0x00, 0x00));
      //      ::W.draw_segment(tap->arc);
      //      ::W.set_line_width(1);
      //      ::W.set_color(color(0x00, 0x00, 0xFF));
      //      ::W.draw_segment(s);
      //::W.read_mouse();
      return true;
    }
    if (tap->from->node == s.start() && tap->to->node != s.end()) {
      if (tap->arc.contains(s.end()) || s.contains(tap->to->node)) {
	//::W.clear();
	//::W.set_line_width(2);
	//	::W.set_color(color(0xFF, 0x00, 0x00));
	//	::W.draw_segment(tap->arc);
	//	::W.set_line_width(1);
	//	::W.set_color(color(0x00, 0x00, 0xFF));
	//	::W.draw_segment(s);
	//	::W.read_mouse();
	return true;
      }
    }
    if (tap->from->node == s.end() && tap->to->node != s.start()) {
      if (tap->arc.contains(s.start()) || s.contains(tap->to->node)) {
	//::W.clear();
	//::W.set_line_width(2);
	//	::W.set_color(color(0xFF, 0x00, 0x00));
	//	::W.draw_segment(tap->arc);
	//	::W.set_line_width(1);
	//	::W.set_color(color(0x00, 0x00, 0xFF));
	//	::W.draw_segment(s);
	//	::W.read_mouse();
	return true;
      }
    }
    if (tap->to->node == s.start() && tap->from->node != s.end()) {
      if (tap->arc.contains(s.end()) || s.contains(tap->from->node)) {
	//::W.clear();
	//::W.set_line_width(2);
	//	::W.set_color(color(0xFF, 0x00, 0x00));
	//	::W.draw_segment(tap->arc);
	//	::W.set_line_width(1);
	//	::W.set_color(color(0x00, 0x00, 0xFF));
	//	::W.draw_segment(s);
	//	::W.read_mouse();
	return true;
      }
    }
    if (tap->to->node == s.end() && tap->from->node != s.start()) {
      if (tap->arc.contains(s.start()) || s.contains(tap->from->node)) {
	//::W.clear();
	//::W.set_line_width(2);
	//	::W.set_color(color(0xFF, 0x00, 0x00));
	//	::W.draw_segment(tap->arc);
	//	::W.set_line_width(1);
	//	::W.set_color(color(0x00, 0x00, 0xFF));
	//	::W.draw_segment(s);
	//	::W.read_mouse();
	return true;
      }
    }
    if (tap->from->node != s.start() &&
	tap->from->node != s.end()   &&
	tap->to->node   != s.start() &&
	tap->to->node   != s.end()) {
      if (s.intersection(tap->arc)) {
	//::W.clear();
	//::W.set_line_width(2);
	//	::W.set_color(color(0xFF, 0x00, 0x00));
	//	::W.draw_segment(tap->arc);
	//	::W.set_line_width(1);
	//	::W.set_color(color(0x00, 0x00, 0xFF));
	//	::W.draw_segment(s);
	//	::W.read_mouse();
	return true;
      }
    }
    //    ::W.clear();
    //    ::W.set_line_width(2);
    //    ::W.set_color(color(0x00, 0x80, 0x00));
    //    ::W.draw_segment(tap->arc);
    //    ::W.set_line_width(1);
    //    ::W.set_color(color(0x00, 0x00, 0x00));
    //    ::W.draw_segment(s);
    //    ::W.read_mouse();
    tap = tap->next;
  }

  //  ::W.set_line_width(1);
  // ::W.clear();
  // cout << "false" << endl;
  return false;
}

bool MyGraph::is_cross(MyArc* s)
{
  return (is_cross(s->arc));
}

bool MyGraph::is_cross(MyArc s)
{
  return (is_cross(s.arc));
}

void MyGraph::get_arcs(void)
{
  MyNode* tp = nodes->next;

  arcs = new MyArc(nodes, nodes->next);
  while (tp->next != NULL) {
    arcs->append(tp, tp->next);
    tp = tp->next;
  }
  arcs->append(tp, nodes);
  return;
}

void MyGraph::get_space(void)
{
  get_space(NULL);
  return;
}

void MyGraph::get_space(window *W)
{
  MyNode* tp = nodes;
  MyNode* sp = space_nodes;
  MyNode* np = space_nodes;
  MyArc*  ap;
  list<point> L;
  list<point> CH;
  point   t;
  segment s;
  MyNode* time;
  MyNode* before;
  MyNode* top;
  MyArc*  a;
  MyArc*  add;

  /*
  ap = get_arc(tp);
  sp = space_nodes;
  while (sp->node != ap->from->node) {
    sp = sp->next;
  }
  np = space_nodes;
  while (np->node != ap->to->node) {
    np = np->next;
  }
  space_arcs = new MyArc(sp, np);
  tp = tp->next;
  
  ap = get_arc(tp);
  sp = space_nodes;
  while (sp != NULL) {
    if (sp->node == ap->from->node)
      break;
    sp = sp->next;
  }
  np = space_nodes;
  while (np != NULL) { 
    if (np->node == ap->to->node)
      break;
    np = np->next;
  }
  if (sp != NULL && np != NULL)
    space_arcs = new MyArc(sp, np);
  tp = tp->next;
  while (tp != NULL) {
    ap = get_arc(tp);
    sp = space_nodes;
    while (sp != NULL) {
      if (sp->node == ap->from->node)
	break;
      sp = sp->next;
    }
    np = space_nodes;
    while (np != NULL) { 
      if (np->node == ap->to->node)
	break;
      np = np->next;
    }
    if (sp != NULL && np != NULL) {
      a = new MyArc(sp, np);
      if (space_arcs == NULL)
	space_arcs = a;
      else
	space_arcs->append(a);
    }
    tp = tp->next;
  }
  */
  tp = space_nodes;

  while (tp != NULL) {
    L.append(tp->node);
    tp = tp->next;
  }

  CH = CONVEX_HULL(L);
  t = CH.Pop();

  top = before = get_space_node(t);
  while (CH.empty() != true) {
    t = CH.Pop();
    time = get_space_node(t);
    a = new MyArc(before, time);
    if (is_in(a) != true)
      space_arcs->append(a);
    else
      delete a;
    before = time;
  }

  a = new MyArc(time, top);

  if (is_in(a) != true)
    space_arcs->append(a);

  tp = space_nodes;
  while (tp != NULL) {
    sp = tp->next;
    while (sp != NULL) {
      s = segment(tp->node, sp->node);
      if (is_cross(s) == false) {
	space_arcs->append(new MyArc(tp, sp));
      }
      sp = sp->next;
    }
    tp = tp->next;
  }

  /*
  ap = space_arcs;
  while (ap != NULL) {
    a = ap->next;
    while (a != NULL) {
      if (ap->from == a->from) {
      s = segment(ap->to->node, a->to->node);
	if (is_in(s) == false && is_cross(s) == false) {
	  space_arcs->append(new MyArc(ap->to, a->to));
	}
      } else if (ap->from == a->to) {
	s = segment(ap->to->node, a->from->node);
	if (is_in(s) == false && is_cross(s) == false) {
	  space_arcs->append(new MyArc(ap->from, a->to));
	}
      } else if (ap->from == a->to) {
	s = segment(ap->to->node, a->from->node);
	if (is_in(s) == false && is_cross(s) == false) {
	  space_arcs->append(new MyArc(ap->to, a->from));
	}
      } else if (ap->to == a->to) {
	s = segment(ap->from->node, a->from->node);
	if (is_in(s) == false && is_cross(s) == false) {
	  space_arcs->append(new MyArc(ap->from, a->from));
	}
      }
      a = a->next;
    }
    ap = ap->next;
  }
  */

  return;
}

MyNode* MyGraph::get_node(point p)
{
  MyNode* tp;

  tp = nodes;
  while (tp->node != p && tp != NULL) {
    tp = tp->next;
  }
  return tp;
}


MyNode* MyGraph::get_node(MyNode* t)
{
  MyNode* tp;

  tp = nodes;
  while (tp->node != t->node && tp != NULL) {
    tp = tp->next;
  }
  return tp;
}

MyNode* MyGraph::get_space_node(point p)
{
  MyNode* tp;

  tp = space_nodes;
  while (tp->node != p && tp != NULL) {
    tp = tp->next;
  }
  return tp;
}
/*
MyNode* MyGraph::get_space_node(MyNode* t)
{
  MyNode* tp;

  tp = space_nodes;
  while (tp->node != t->node && tp != NULL) {
    tp = tp->next;
  }
  return tp;
}
*/
MyArc* MyGraph::get_arc(MyNode* xp)
{
  MyArc* ap;
  
  ap = arcs;
  while (ap != NULL) {
    if (ap->from == xp) {
      return ap;
    }
    ap = ap->next;
  }
  ap = arcs;
  while (ap != NULL) {
    if (ap->to == xp) {
      return ap;
    }
    ap = ap->next;
  }
  return ap;
}

MyArc* MyGraph::get_space_arc(MyNode* xp)
{
  MyArc* ap;

  ap = space_arcs;
  while (ap != NULL) {
    if (ap->from == xp || ap->to == xp) {
      return ap;
    }
    if (ap->from->node == xp->node || ap->to->node == xp->node) {
      return ap;
    }
    ap = ap->next;
  }
  return ap;
}

bool MyGraph::is_connect(MyArc* a, MyArc* b)
{
  if (a->from == b->from || a->from == b->to || a->to == b->from || a->to == b->to)
    return true;

  return false;
}

bool MyGraph::is_there_inner_point(MyNode* a, MyNode* b, MyNode* c)
{
  MyNode* p;
  list<point> L, H;
  int i;

  double x_min, x_max, y_min, y_max;

  segment bc, ca, ab, pa, pb, pc;

  bc = segment(b->node, c->node);
  ca = segment(c->node, a->node);
  ab = segment(a->node, b->node);

  x_max = x_min = a->node.xcoord();
  y_max = y_min = a->node.ycoord();

  if (b->node.xcoord() < x_min)
    x_min = b->node.xcoord();
  if (b->node.xcoord() > x_max)
    x_max = b->node.xcoord();
  if (b->node.ycoord() < y_min)
    y_min = b->node.ycoord();
  if (b->node.ycoord() > y_max)
    y_max = b->node.ycoord();

  if (c->node.xcoord() < x_min)
    x_min = c->node.xcoord();
  if (c->node.xcoord() > x_max)
    x_max = c->node.xcoord();
  if (c->node.ycoord() < y_min)
    y_min = c->node.ycoord();
  if (c->node.ycoord() > y_max)
    y_max = c->node.ycoord();

  p  = space_nodes;
  while (p != NULL) {
    if (p != a && p != b && p != c) {
      if (p->node.xcoord() >= x_min && p->node.xcoord() <= x_max && p->node.ycoord() >= y_min && p->node.ycoord() <= y_max) {
	pa = segment(p->node, a->node);
	pb = segment(p->node, b->node);
	pc = segment(p->node, c->node);
	if (!pa.intersection(bc) && !pb.intersection(ca) && !pc.intersection(ab))
	  return true;
      }
    }
    p = p->next;
  }

  return false;
}

bool MyGraph::is_triangule(MyArc* a, MyArc* b, MyArc* c)
{
  if (a->from == b->from) {
    if (c->from == a->to && c->to == b->to)
      return true;
    if (c->from == b->to && c->to == a->to)
      return true;
  }
  if (a->from == b->to) {
    if (c->from == a->to && c->to == b->from)
      return true;
    if (c->from == b->from && c->to == a->to)
      return true;
  }
  if (a->to == b->from) {
    if (c->from == a->from && c->to == b->to)
      return true;
    if (c->from == b->to && c->to == a->from)
      return true;
  }
  if (a->to == b->to) {
    if (c->from == a->from && c->to == b->from)
      return true;
    if (c->from == b->from && c->to == a->from)
      return true;
  }

  return false;
}

MyNode* MyGraph::get_polygons(void)
{
  MyNode* p;

  MyArc* a;
  MyArc* b;
  MyArc* c;

  MyNode* uno;
  MyNode* dos;
  MyNode* tres;

  MyNode* quatro;

  list<point> L, H;

  p = NULL;

  get_space();

  a = space_arcs;
  while (a != NULL) {
    b  = a->next;
    while (b != NULL) {
      c = b->next;
      while (c != NULL) {
	//	if (is_connect(a, b) && is_connect(b, c) && is_connect(c, a)) {
	if (is_triangule(a, b, c)) {
	  //	  cout << "there is triangul." << endl;
	  uno = a->from;
	  dos = a->to;
	  if (b->from != uno && b->from != dos)
	    tres = b->from;
	  if (b->to != uno && b->to != dos)
	    tres = b->to;
	  if (c->from != uno && c->from != dos)
	    tres = c->from;
	  if (c->to != uno && c->to != dos)
	    tres = c->to;
	  if (is_there_inner_point(uno, dos, tres) == false) {
	    if (p == NULL)
	      p = new MyNode(uno->node);
	    else
	      p->append(uno->node);
	    p->append(dos->node);
	    p->append(tres->node);
	    //	    ::W.clear();
	    //	    ::W.draw_segment(a->arc);
	    //	    ::W.draw_segment(b->arc);
	    //	    ::W.draw_segment(c->arc);
	    //	    ::W.read_mouse();
	  }
	}
	c = c->next;
      }
      b = b->next;
    }
    a = a->next;
  }
  return p;
}

// class Polygon
Polygon::Polygon(D3MyNode* uno, D3MyNode* dos, D3MyNode* tres)
{
  initialize(uno, dos, tres);
}

Polygon::~Polygon(void)
{
  remove();
}

void Polygon::initialize(void)
{
  a = NULL;
  b = NULL;
  c = NULL;

  bc = NULL;
  ca = NULL;
  ab = NULL;

  before = NULL;
  next   = NULL;

  return;
}

void Polygon::initialize(D3MyNode* uno, D3MyNode* dos, D3MyNode* tres)
{
  initialize();
  input(uno, dos, tres);
  return;
}

void Polygon::remove(void)
{
  if (before != NULL)
    before->next = next;
  if (next != NULL)
    next->before = before;
  before = NULL;
  next = NULL;
  return;
}

Polygon* Polygon::head(void)
{
  if (before == NULL)
    return this;
  else
    return before->head();
}

Polygon* Polygon::tail(void)
{
  if (next == NULL)
    return this;
  else
    return next->tail();
}

Polygon* Polygon::insert(D3MyNode* uno, D3MyNode* dos, D3MyNode* tres)
{
  Polygon* tp;

  tp = new Polygon(uno, dos, tres);
  tp->before = this;
  tp->next = next;
  if (next != NULL)
    next->before = tp;
  next = tp;

  return tp;
}

Polygon* Polygon::insert(Polygon* tp)
{
  //  cout << 0 << endl;
  if (tp->before != NULL)
    tp->before->next = NULL;
  //  cout << 1 << endl;
  tp->before = this;
  //  cout << 2 << endl;
  if (next != NULL)
    next->before = tp->tail();
  //  cout << 3 << endl;
  tp->tail()->next = next;
  //  cout << 4 << endl;
  next = tp;
  //  cout << 5 << endl;

  return tp;
}

Polygon* Polygon::append(D3MyNode* uno, D3MyNode* dos, D3MyNode* tres)
{
  return tail()->insert(uno, dos, tres);
}

Polygon* Polygon::append(Polygon* tp)
{
  return tail()->insert(tp);
}

Polygon* Polygon::push(D3MyNode* uno, D3MyNode* dos, D3MyNode* tres)
{
  return append(uno, dos, tres);
}

Polygon* Polygon::push(Polygon* tp)
{
  return append(tp);
}

void Polygon::input(D3MyNode* uno, D3MyNode* dos, D3MyNode* tres)
{
  a = uno;
  b = dos;
  c = tres;

  bc = new D3MyArc(b, c);
  ca = new D3MyArc(c, a);
  ab = new D3MyArc(a, b);

  /*
  cout << a->node << endl;
  cout << b->node << endl;
  cout << c->node << endl;
  */

  //  convert();
}

D3MyNode* Polygon::search(d3_point x)
{
  D3MyNode* tp;

  tp = search_before(x);
  if (tp != NULL)
    return tp;
  tp = search_next(x);
  if (tp != NULL)
    return tp;
  return NULL;
}

D3MyNode* Polygon::search_before(d3_point x)
{
  if (x == a->node)
    return a;
  if (x == b->node)
    return b;
  if (x == c->node)
    return c;
  if (before == NULL)
    return NULL;
  return before->search_before(x);
}

D3MyNode* Polygon::search_next(d3_point x)
{
  if (x == a->node)
    return a;
  if (x == b->node)
    return b;
  if (x == c->node)
    return c;
  if (next == NULL)
    return NULL;
  return next->search_next(x);
}

D3MyNode* Polygon::search(D3MyNode* x)
{
  D3MyNode* tp;
  //  ::_time = 0;

  //  cout << "polygon node search" << endl;
  tp = search_before(x);
  //  cout << "polygon node search_before complete" << endl;
  if (tp != NULL) {
    //    cout << "apply!" << endl;
    return tp;
  }
  tp = search_next(x);
  //  cout << "polygon node search_next complete" << endl;
  return tp;
}

D3MyNode* Polygon::search_before(D3MyNode* x)
{
  //  cout << "time = " << ::_time << endl;
  //  ::_time++;
  /*
  if (a == NULL)
    cout << "error!!" << endl;
  if (b == NULL)
    cout << "error!!" << endl;
  if (c == NULL)
    cout << "error!!" << endl;
  cout << "searching point to before..." << endl;
  cout << x;
  cout << " = " << x->node << endl;
  cout << a;
  cout << " = " << a->node << endl;
  cout << b;
  cout << " = " << b->node << endl;
  cout << c;
  cout << " = " << c->node << endl;
  */
  if (x != a && x->node == a->node)
    return a;
  if (x != b && x->node == b->node)
    return b;
  if (x != c && x->node == c->node)
    return c;
  if (before == NULL)
    return NULL;
  return before->search_before(x);
}

D3MyNode* Polygon::search_next(D3MyNode* x)
{
  //  cout << "time = " << ::_time << endl;
  //  ::_time++;
  /*
  if (a == NULL)
    cout << "error!!" << endl;
  if (b == NULL)
    cout << "error!!" << endl;
  if (c == NULL)
    cout << "error!!" << endl;
  cout << "searching node to next for polygon..." << endl;
  cout << x << endl;
  cout << " = " << x->node << endl;
  cout << a << endl;
  cout << " = " << a->node << endl;
  cout << b << endl;
  cout << " = " << b->node << endl;
  cout << c << endl;
  cout << " = " << c->node << endl;
  */
  if (x != a && x->node == a->node)
    return a;
  if (x != b && x->node == b->node)
    return b;
  if (x != c && x->node == c->node)
    return c;
  if (next == NULL)
    return NULL;
  return next->search_next(x);
}

D3MyArc* Polygon::search(D3MyArc* x)
{
  D3MyArc* tp;

  //  cout << "polygon point search" << endl;
  tp = search_before(x);
  //  cout << "polygon point search_before complete" << endl;
  if (tp != NULL) {
    //    cout << "apply!!!" << endl;
    return tp;
  }
  tp = search_next(x);
  //  cout << "polygon point search_next complete" << endl;
  return tp;
}

D3MyArc* Polygon::search_before(D3MyArc* x)
{
  /*
  if (bc = NULL)
    cout << "error!!" << endl;
  if (ca == NULL)
    cout << "error!!" << endl;
  if (ab == NULL)
    cout << "error!!" << endl;
  cout << "searching before..." << endl;
  cout << x;
  cout << " = " << x->arc << endl;
  cout << bc;
  cout << " = " << bc->arc << endl;
  cout << ca;
  cout << " = " << ca->arc << endl;
  cout << ab;
  cout << " = " << ab->arc << endl;
  */
  if (((x->from == bc->from && x->to == bc->to) || (x->from == bc->to && x->to == bc->from)) && x != bc)
    return bc;
  if (((x->from == ca->from && x->to == ca->to) || (x->from == ca->to && x->to == ca->from)) && x != ca)
    return ca;
  if (((x->from == ab->from && x->to == ab->to) || (x->from == ab->to && x->to == ab->from)) && x != ab)
    return ab;
  if (before == NULL)
    return NULL;
  return before->search_before(x);
}

D3MyArc* Polygon::search_next(D3MyArc* x)
{
  /*
  if (bc == NULL)
    cout << "error!!" << endl;
  if (ca == NULL)
    cout << "error!!" << endl;
  if (ab == NULL)
    cout << "error!!" << endl;
  cout << "searching next..." << endl;
  cout << x;
  cout << " = " << x->arc << endl;
  cout << bc;
  cout << " = " << bc->arc << endl;
  cout << ca;
  cout << " = " << ca->arc << endl;
  cout << ab;
  cout << " = " << ab->arc << endl;
  */
  if (((x->from == bc->from && x->to == bc->to) || (x->from == bc->to && x->to == bc->from)) && x != bc)
    return bc;
  if (((x->from == ca->from && x->to == ca->to) || (x->from == ca->to && x->to == ca->from)) && x != ca)
    return ca;
  if (((x->from == ab->from && x->to == ab->to) || (x->from == ab->to && x->to == ab->from)) && x != ab)
    return ab;
  if (next == NULL)
    return NULL;
  return next->search_next(x);
}

Polygon* Polygon::subdivision(void)
{
  Polygon* root;
  Polygon* tp;

  D3MyNode* g;
  D3MyNode* bc_center;
  D3MyNode* ca_center;
  D3MyNode* ab_center;
  d3_point p;
  // static int timing;

  int i;

  //  cout << timing++ << "th subdividing" << endl;

  p = d3_point((b->node.xcoord()+c->node.xcoord())/2, (b->node.ycoord()+c->node.ycoord())/2, (b->node.zcoord()+c->node.zcoord())/2);
  //  bc_center = search(p);
  //  if (bc_center == NULL)
  bc_center = new D3MyNode(p);
  bc_center->in_knot = bc->in_knot;
  p = d3_point((c->node.xcoord()+a->node.xcoord())/2, (c->node.ycoord()+a->node.ycoord())/2, (c->node.zcoord()+a->node.zcoord())/2);
  //  ca_center = search(p);
  //  if (ca_center == NULL)
  ca_center = new D3MyNode(p);
  ca_center->in_knot = ca->in_knot;
  p = d3_point((a->node.xcoord()+b->node.xcoord())/2, (a->node.ycoord()+b->node.ycoord())/2, (a->node.zcoord()+b->node.zcoord())/2);
  //  ab_center = search(p);
  //  if (ab_center == NULL)
  ab_center = new D3MyNode(p);
  ab_center->in_knot = ab->in_knot;

  p = d3_point((a->node.xcoord()+b->node.xcoord()+c->node.xcoord())/3, (a->node.ycoord()+b->node.ycoord()+c->node.ycoord())/3, (a->node.zcoord()+b->node.zcoord()+c->node.zcoord())/3);

  g = new D3MyNode(p);

  tp = root = new Polygon(a, ab_center, g);
  tp->b->in_knot = tp->ab->in_knot = ab->in_knot; 
  tp = root->append(a, ca_center, g);
  tp->b->in_knot = tp->ab->in_knot = ca->in_knot;
  tp = root->append(b, ab_center, g);
  tp->b->in_knot = tp->ab->in_knot = ab->in_knot;
  tp = root->append(b, bc_center, g);
  tp->b->in_knot = tp->ab->in_knot = bc->in_knot;
  tp = root->append(c, ca_center, g);
  tp->b->in_knot = tp->ab->in_knot = ca->in_knot;;
  tp = root->append(c, bc_center, g);
  tp->b->in_knot = tp->ab->in_knot = bc->in_knot;

  /*
  for (i = 0; i < 6; i < 6) {
    tp = root;
    if (root->a->in_knot == false && root->b->in_knot == false && root->c-> in_knot == false) {
      root = root->next;
      delete tp;
      continue;
    } 
    tp = tp->next;
    while (tp != NULL) {
      if (tp->a->in_knot == false && tp->b->in_knot == false && tp->c->in_knot == false) {
	delete tp;
	break;
      }
      tp = tp->next;
    }
  }
  */

  return root;
}

void Polygon::convert(void)
{
  D3MyNode* np;
  D3MyArc*  ap;

  /*
  Polygon* pp;

  pp = this->before;
  while (pp != NULL) {
    cout << pp->a << pp->b << pp->c << endl;
    pp = pp->before;
  }
  pp = this->next;
  while (pp != NULL) {
    cout << pp->a << pp->b << pp->c << endl;
    pp = pp->next;
  }
  */

  //  cout << "Polygon convert start" << endl;

  //  cout << "point check..." << endl;
  np = search(a);
  if (np != NULL) {
    //    cout << np << " = a = " << a << endl;
    delete ca;
    ca = new D3MyArc(c, np);
    delete ab;
    ab = new D3MyArc(np, b);
    delete a;
    a = np;
  }
  np = search(b);
  if (np != NULL) {
    //    cout << np << " = b = " << a << endl;
    delete ab;
    ab = new D3MyArc(a, np);
    delete bc;
    bc = new D3MyArc(np, c);
    delete b;
    b = np;
  }
  np = search(c);
  if (np != NULL) {
    //    cout << np << " = c = " << a << endl;
    delete bc;
    bc = new D3MyArc(b, np);
    delete ca;
    ca = new D3MyArc(np, a);
    delete c;
    c = np;
  }

  //  cout << "segment check..." << endl;

  ap = search(bc);
  if (ap != NULL) {
    delete bc;
    bc = ap;
  }
  ap = search(ca);
  if (ap != NULL) {
    delete ca;
    ca = ap;
  }
  ap = search(ab);
  if (ap != NULL) {
    delete ab;
    ab = ap;
  }

  //  cout << "polygon convert complete." << endl;

  return;
}

Pillar::Pillar(MyNode* a, MyNode* b, MyNode* c)
{
  initialize(a, b, c);
}

void Pillar::initialize(void)
{
  ceiling = NULL;
  floor   = NULL;
  before  = NULL;
  next    = NULL;
  bc_wall = NULL;
  ca_wall = NULL;
  ab_wall = NULL;
  return;
}

void Pillar::initialize(MyNode* a, MyNode* b, MyNode* c)
{
  D3MyNode* uno;
  D3MyNode* dos;
  D3MyNode* tres;

  initialize();

  m_a = a->node;
  m_b = b->node;
  m_c = c->node;

  uno  = new D3MyNode(a, HEIGHT);
  dos  = new D3MyNode(b, HEIGHT);
  tres = new D3MyNode(c, HEIGHT);
  ceiling = new Polygon(uno, dos, tres);

  uno  = new D3MyNode(a, - HEIGHT);
  dos  = new D3MyNode(b, - HEIGHT);
  tres = new D3MyNode(c, - HEIGHT);
  floor   = new Polygon(uno, dos, tres);

  //   cout << uno << " " << dos << " " << tres << endl;

  ceiling->append(floor);

  //   cout << "appennd complete." << endl;

  uno = new D3MyNode(d3_point((b->node.xcoord()+c->node.xcoord())/2, (b->node.ycoord()+c->node.ycoord())/2, 0.0));
  bc_wall = new Polygon(ceiling->b, ceiling->c, uno);
  bc_wall->append(floor->c, floor->b, uno);
  bc_wall->append(ceiling->b, floor->b, uno);
  bc_wall->append(floor->c, ceiling->c, uno);

  dos = new D3MyNode(d3_point((c->node.xcoord()+a->node.xcoord())/2, (c->node.ycoord()+a->node.ycoord())/2, 0.0));
  ca_wall = new Polygon(ceiling->c, ceiling->a, dos);
  ca_wall->append(floor->a, floor->c, dos);
  ca_wall->append(ceiling->c, floor->c, dos);
  ca_wall->append(floor->a, ceiling->a, dos);

  tres = new D3MyNode(d3_point((a->node.xcoord()+b->node.xcoord())/2, (a->node.ycoord()+b->node.ycoord())/2, 0.0));
  ab_wall = new Polygon(ceiling->a, ceiling->b, tres);
  ab_wall->append(floor->b, floor->a, tres);
  ab_wall->append(ceiling->a, floor->a, tres);
  ab_wall->append(floor->b, ceiling->b, tres);

  ceiling->append(bc_wall);
  ceiling->append(ca_wall);
  ceiling->append(ab_wall);

  //  cout << "make pillar complete" << endl;

  return;
}

Pillar* Pillar::head(void)
{
  if (before == NULL)
    return this;
  return before->head();
}

Pillar* Pillar::tail(void)
{
  if (next == NULL)
    return this;
  return next->tail();
}

Pillar* Pillar::insert(MyNode* a, MyNode* b, MyNode* c)
{
  Pillar* tp;

  tp = new Pillar(a, b, c);
  tp->before = this;
  tp->next = next;
  if (next != NULL)
    next->before = tp;
  next = tp;

  return tp;
}

Pillar* Pillar::insert(Pillar* tp)
{
  //  cout << 0 << endl;
  if (tp->before != NULL)
    tp->before->next = NULL;
  //  cout << 1 << endl;
  tp->before = this;
  //  cout << 2 << endl;
  if (next != NULL)
    next->before = tp->tail();
  //  cout << 3 << endl;
  tp->tail()->next = next;
  //  cout << 4 << endl;
  next = tp;

  //  cout << "insert complete." << endl;

  return tp;
}

Pillar* Pillar::append(MyNode* a, MyNode* b, MyNode* c)
{
  return tail()->insert(a, b, c);
}

Pillar* Pillar::append(Pillar* tp)
{
  return tail()->insert(tp);
}

Pillar* Pillar::push(MyNode* a, MyNode* b, MyNode* c)
{
  return append(a, b, c);
}

Pillar* Pillar::push(Pillar* tp)
{
  return append(tp);
}

D3MyNode* Pillar::search(D3MyNode* x)
{
  D3MyNode* tp;

  //  cout << "pillar point search" << endl;
  tp = ceiling->search(x);
  //  cout << "ceiling->search complete" << endl;
  if (tp != NULL)
    return tp;
  tp = search_before(x);
  if (tp != NULL)
    return tp;
  tp = search_next(x);
  return tp;
}

D3MyNode* Pillar::search_before(D3MyNode* x)
{
  D3MyNode* tp;

  tp = ceiling->search(x);
  if (tp != NULL)
    return tp;
  if (before == NULL)
    return NULL;
  return before->search_before(x);
}

D3MyNode* Pillar::search_next(D3MyNode* x)
{
  D3MyNode* tp;

  tp = ceiling->search(x);
  if (tp != NULL)
    return tp;
  if (next == NULL)
    return NULL;
  return next->search_next(x);
}

D3MyArc* Pillar::search(D3MyArc* x)
{
  D3MyArc* tp;

  tp = ceiling->search(x);
  if (tp != NULL)
    return tp;
  tp = search_before(x);
  if (tp != NULL)
    return tp;
  tp = search_next(x);
  return tp;
}

D3MyArc* Pillar::search_before(D3MyArc* x)
{
  D3MyArc* tp;

  tp = ceiling->search(x);
  if (tp != NULL)
    return tp;
  if (before == NULL)
    return NULL;
  return before->search_before(x);
}

D3MyArc* Pillar::search_next(D3MyArc* x)
{
  D3MyArc* tp;

  tp = ceiling->search(x);
  if (tp != NULL)
    return tp;
  if (next == NULL)
    return NULL;
  return next->search_next(x);
}

void Pillar::convert(void)
{
  Polygon* tp;
  D3MyNode* x;
  D3MyArc*  a;

  /*
  tp = ceiling;
  while (tp != NULL) {
    cout << tp->a->node << tp->b->node << tp->c->node << endl;
    tp = tp->next;
  }
  */

  //  cout << "pillar convert start." << endl;

  x = NULL;
  tp = ceiling;
  while (tp != NULL) {
    //    cout << "point checking..." << endl;
    x = search(tp->a);
    //    cout << "tp->a checked" << endl;
    if (x != NULL) {
      //      cout << x << " = " << tp->a << " = " << x->node << " = " << tp->a->node << endl;
      delete tp->ab;
      //      cout << 1 << endl;
      tp->ab = new D3MyArc(x, tp->b);
      //      cout << 2 << endl;
      delete tp->ca;
      //      cout << 3 << endl;
      tp->ca = new D3MyArc(tp->c, x);
      //      cout << 4 << endl;
      delete tp->a;
      //      cout << 5 << endl;
      tp->a = x;

      /*
      cout << tp->a->node << endl;
      cout << tp->b->node << endl;
      cout << tp->c->node << endl;
      cout << tp->bc->arc << endl;
      cout << tp->ca->arc << endl;
      cout << tp->ab->arc << endl;
      cout << tp << endl;
      cout << tp->a << endl;
      cout << tp->b << endl;
      cout << tp->c << endl;
      cout << tp->bc << endl;
      cout << tp->ca << endl;
      cout << tp->ab << endl;
      */
    }
    x = search(tp->b);
    //    cout << "tp->b checked" << endl;
    if (x != NULL) {
      //      cout << x << " = " << tp->b << " = " << x->node << " = " << tp->b->node << endl;
      delete tp->bc;
      //      cout << 11 << endl;
      tp->bc = new D3MyArc(x, tp->c);
      //      cout << 12 << endl;
      delete tp->ab;
      //      cout << 13 << endl;
      tp->ab = new D3MyArc(tp->a, x);
      //      cout << 14 << endl;
      delete tp->b;
      //      cout << 15 << endl;
      tp->b = x;
      /*
      cout << tp << endl;
      cout << tp->a << endl;
      cout << tp->b << endl;
      cout << tp->c << endl;
      cout << tp->bc << endl;
      cout << tp->ca << endl;
      cout << tp->ab << endl;
      */
    }
    x = search(tp->c);
    //    cout << "tp->c checked" << endl;
    if (x != NULL) {
      //      cout << x << " = " << tp->c << " = " << x->node << " = " << tp->c->node << endl;
      delete tp->bc;
      //      cout << 11 << endl;
      tp->bc = new D3MyArc(tp->b, x);
      //      cout << 12 << endl;
      delete tp->ca;
      //      cout << 13 << endl;
      tp->ca = new D3MyArc(x, tp->a);
      //      cout << 14 << endl;
      delete tp->c;
      //      cout << 15 << endl;
      tp->c = x;
      /*
      cout << tp << endl;
      cout << tp->a << endl;
      cout << tp->b << endl;
      cout << tp->c << endl;
      cout << tp->bc << endl;
      cout << tp->ca << endl;
      cout << tp->ab << endl;
      */
    }

    //    cout << "edge checking..." << endl;
    a = tp->search(tp->bc);
    if (a != NULL) {
      delete tp->bc;
      tp->bc = a;
    }
    a = search(tp->ca);
    if (a != NULL) {
      delete tp->ca;
      tp->ca = a;
    }
    a = search(tp->ab);
    if (a != NULL) {
      delete tp->ab;
      tp->ab = a;
    }

    tp = tp->next;
  }

  //  cout << "pillar convert complete" << endl;
  return;
}



void Pillar::switching(MyNode* knot)
{
  bool time[6];
  bool log[6];
  bool node[6];
  bool arc[6][6];
  MyNode* tp;

  //  convert();

  int i, j;

  for (i = 0; i < 6; i++) {
    time[i] = false;
    log[i]  = false;
    node[i] = false;
  }
  for (i = 0; i < 6; i++) {
    for (j = 0; j < 6; j++)
      arc[i][j] = false;
  }

  tp = knot;
  while (tp != NULL) {
    if (m_a == tp->node) {
      time[0] = !(tp->upper);
      time[1] = tp->upper;
    }
    if (m_b == tp->node) {
      time[2] = !(tp->upper);
      time[3] = tp->upper;
    }
    if (m_c == tp->node) {
      time[4] = !(tp->upper);
      time[5] = tp->upper;
    }

    for (i = 0; i < 6; i++)
      node[i] = node[i] || time[i];

    for (i = 0; i < 6; i++) {
      for (j = 0; j < 6; j++) {
	arc[i][j] = arc[i][j] || arc[j][i] || (time[i] && log[j]) || (time[j] && log[j]);
      }
    }

    for (i = 0; i < 6; i++) {
      log[i] = time[i];
      time[i] = false;
    }

    tp = tp->next;
  }

  if (m_a == knot->node) {
      time[0] = !(knot->upper);
      time[1] = knot->upper;
  }
  if (m_b == knot->node) {
      time[2] = !(knot->upper);
      time[3] = knot->upper;
  }
  if (m_c == knot->node) {
      time[4] = !(knot->upper);
      time[5] = knot->upper;
  }

  tp = knot->tail();
  if (m_a == tp->node) {
      log[0] = !(tp->upper);
      log[1] = tp->upper;
  }
  if (m_b == tp->node) {
    log[2] = !(tp->upper);
    log[3] = tp->upper;
  }
  if (m_c == tp->node) {
      log[4] = !(tp->upper);
      log[5] = tp->upper;
  }
  for (i = 0; i < 6; i++) {
    for (j = 0; j < 6; j++) {
      arc[i][j] = arc[i][j] || arc[j][i] || (time[i] && log[j]) || (time[j] && log[i]);
    }
  }

  ceiling->a->in_knot = node[1];
  ceiling->b->in_knot = node[3];
  ceiling->c->in_knot = node[5];
  ceiling->bc->in_knot = arc[3][5];
  ceiling->ca->in_knot = arc[1][5];
  ceiling->ab->in_knot = arc[1][3];

  floor->a->in_knot = node[0];
  floor->b->in_knot = node[2];
  floor->c->in_knot = node[4];
  floor->bc->in_knot = arc[2][4];
  floor->ca->in_knot = arc[0][4];
  floor->ab->in_knot = arc[0][2];
  
  bc_wall->c->in_knot = arc[2][5] || arc[3][4];
  bc_wall->bc->in_knot = arc[2][5];
  bc_wall->ca->in_knot = arc[3][4];
  bc_wall->ab->in_knot = arc[3][5];
  bc_wall->next->bc->in_knot = arc[2][5];
  bc_wall->next->ca->in_knot = arc[3][4];
  bc_wall->next->ab->in_knot = arc[2][4];
  bc_wall->next->next->bc->in_knot = arc[2][5];
  bc_wall->next->next->ca->in_knot = arc[3][4];
  bc_wall->next->next->ab->in_knot = arc[2][3];
  bc_wall->next->next->next->bc->in_knot = arc[2][5];
  bc_wall->next->next->next->ca->in_knot = arc[3][4];
  bc_wall->next->next->next->ab->in_knot = arc[4][5];

  ca_wall->c->in_knot = arc[0][5] || arc[1][4];
  ca_wall->bc->in_knot = arc[1][4];
  ca_wall->ca->in_knot = arc[0][5];
  ca_wall->ab->in_knot = arc[1][5];
  ca_wall->next->bc->in_knot = arc[1][4];
  ca_wall->next->ca->in_knot = arc[0][5];
  ca_wall->next->ab->in_knot = arc[0][4];
  ca_wall->next->next->bc->in_knot = arc[1][4];
  ca_wall->next->next->ca->in_knot = arc[0][5];
  ca_wall->next->next->ab->in_knot = arc[4][5];
  ca_wall->next->next->next->bc->in_knot = arc[1][4];
  ca_wall->next->next->next->ca->in_knot = arc[0][5];
  ca_wall->next->next->next->ab->in_knot = arc[0][1];

  ab_wall->c->in_knot = arc[0][3] || arc[1][2];
  ab_wall->bc->in_knot = arc[0][3];
  ab_wall->ca->in_knot = arc[1][2];
  ab_wall->ab->in_knot = arc[1][3];
  ab_wall->next->bc->in_knot = arc[0][3];
  ab_wall->next->ca->in_knot = arc[1][2];
  ab_wall->next->ab->in_knot = arc[0][2];
  ab_wall->next->next->bc->in_knot = arc[0][3];
  ab_wall->next->next->ca->in_knot = arc[1][2];
  ab_wall->next->next->ab->in_knot = arc[0][1];
  ab_wall->next->next->next->bc->in_knot = arc[0][3];
  ab_wall->next->next->next->ca->in_knot = arc[1][2];
  ab_wall->next->next->next->ab->in_knot = arc[2][3];

  return;
}

Tetrahedral* Pillar::get_parts(void)
{
  Polygon* pp;
  Tetrahedral* tp;
  D3MyNode* g;

  Polygon* uno;
  Polygon* dos;
  Polygon* tres;
  Polygon* quatro;

  tp = NULL;

  g = new D3MyNode(d3_point((ceiling->a->node.xcoord()+ceiling->b->node.xcoord()+ceiling->c->node.xcoord())/3, (ceiling->a->node.ycoord()+ceiling->b->node.ycoord()+ceiling->c->node.ycoord())/3, 0.0));


  //  cout << "getting tetrahedral" << endl;
  pp = ceiling;
  while (pp != NULL) {
    //    cout << "pp is " << pp << endl;
    uno = new Polygon(pp->a, pp->b, pp->c);
    uno->bc->in_knot = pp->bc->in_knot;
    uno->ca->in_knot = pp->ca->in_knot;
    uno->ab->in_knot = pp->ab->in_knot;

    dos = new Polygon(g, pp->b, pp->c);
    dos->bc->in_knot = pp->bc->in_knot;

    tres = new Polygon(pp->a, g, pp->c);
    tres->ca->in_knot = pp->ca->in_knot;

    quatro = new Polygon(pp->a, pp->b, g);
    quatro->ab->in_knot = pp->ab->in_knot;

    //    cout << "uno! dos! tres! quatro!" << endl;

    if (tp == NULL)
      tp = new Tetrahedral(uno, dos, tres, quatro);
    else
      tp->append(uno, dos, tres, quatro);

    /*
    cout << endl;
    cout << tp->a->a->node << endl;
    cout << tp->a->b->node << endl;
    cout << tp->a->c->node << endl;
    cout << tp->b->a->node << endl;
    cout << tp->b->b->node << endl;
    cout << tp->b->c->node << endl;
    cout << tp->c->a->node << endl;
    cout << tp->c->b->node << endl;
    cout << tp->c->c->node << endl;
    cout << tp->d->a->node << endl;
    cout << tp->d->b->node << endl;
    cout << tp->d->c->node << endl;
    cout << endl;
    */

    //    cout << "input to tp complete" << endl;

    pp = pp->next;
  }

  return tp;
}

Tetrahedral::Tetrahedral(Polygon* a, Polygon* b, Polygon* c, Polygon* d)
{
  initialize(a, b, c, d);
  return;
}

Tetrahedral::~Tetrahedral(void)
{
  remove();
  return;
}

void Tetrahedral::initialize(void)
{
  a = NULL;
  b = NULL;
  c = NULL;
  d = NULL;
  before = NULL;
  next = NULL;
  return;
}

void Tetrahedral::initialize(Polygon* uno, Polygon* dos, Polygon* tres, Polygon* quatro)
{
  initialize();
  a = uno;
  b = dos;
  c = tres;
  d = quatro;
}

void Tetrahedral::remove(void)
{
  if (before != NULL)
    before->next = next;
  if (next != NULL)
    next->before = before;
  before = NULL;
  next = NULL;
  return;
}

Tetrahedral* Tetrahedral::head(void)
{
  if (before == NULL)
    return this;
  return before->head();
}

Tetrahedral* Tetrahedral::tail(void)
{
  if (next == NULL)
    return this;
  return next->tail();
}

Tetrahedral* Tetrahedral::insert(Polygon* uno, Polygon* dos, Polygon* tres, Polygon* quatro)
{
  Tetrahedral* tp;

  tp = new Tetrahedral(uno, dos, tres, quatro);
  tp->before = this;
  tp->next = next;
  if (next != NULL)
    next->before = tp;
  next = tp;

  return tp;
}

Tetrahedral* Tetrahedral::insert(Tetrahedral* tp)
{
  if (tp->before != NULL)
    tp->before->next = NULL;
  tp->before = this;
  if (next != NULL)
    next->before = tp->tail();
  tp->tail()->next = next;
  next = tp;

  return tp;
}

Tetrahedral* Tetrahedral::append(Polygon* uno, Polygon* dos, Polygon* tres, Polygon* quatro)
{
  return tail()->insert(uno, dos, tres, quatro);
}

Tetrahedral* Tetrahedral::append(Tetrahedral* tp)
{
  return tail()->insert(tp);
}

Tetrahedral* Tetrahedral::push(Polygon* uno, Polygon* dos, Polygon* tres, Polygon* quatro)
{
  return append(uno, dos, tres, quatro);
}

Tetrahedral* Tetrahedral::push(Tetrahedral* tp)
{
  return append(tp);
}

Tetrahedral* Tetrahedral::subdivision(void)
{
  Polygon* face;
  Polygon* pp;
  D3MyNode* g;

  Polygon* uno;
  Polygon* dos;
  Polygon* tres;
  Polygon* quatro;

  face = NULL;

  Tetrahedral* divisions;
  divisions = NULL;
  face = a->subdivision();
  face->append(b->subdivision());
  face->append(c->subdivision());
  face->append(d->subdivision());

  g = get_gravity_point();

  pp = face;
  while (pp != NULL) {
    if (pp->a->in_knot || pp->b->in_knot || pp->c->in_knot) {
      uno = pp;
      dos = new Polygon(g, pp->b, pp->c);
      dos->bc->in_knot = pp->bc->in_knot;
      tres = new Polygon(pp->a, g, pp->c);
      tres->ca->in_knot = pp->ca->in_knot;
      quatro = new Polygon(pp->a, pp->b, g);
      quatro->ab->in_knot = pp->ab->in_knot;

      if (divisions == NULL)
	divisions = new Tetrahedral(uno, dos, tres, quatro);
      else
	divisions->insert(uno, dos, tres, quatro);
    }
    pp = pp->next;
  }
  return divisions;
}

/*
bool operator != (d3_point a, d3_point b)
{
  if (a.xcoord() == b.xcoord() && a.ycoord() == b.yxoord() && a.zcoord() == b.zcoord())
    return false;
  return true;
}
*/

D3MyNode* Tetrahedral::get_gravity_point(void)
{
  d3_point uno;
  d3_point dos;
  d3_point tres;
  d3_point quatro;

  uno  = a->a->node;
  dos  = a->b->node;
  tres = a->c->node;
  if (b->a->node != uno && b->a->node != dos && b->a->node != tres) {
    quatro = b->a->node;
  }
  if (b->b->node != uno && b->b->node != dos && b->b->node != tres) {
    quatro = b->b->node;
  }
  if (b->c->node != uno && b->c->node != dos && b->c->node != tres) {
    quatro = b->c->node;
  }

  // get center gravitiy
  return new D3MyNode(d3_point((uno.xcoord()+dos.xcoord()+tres.xcoord()+quatro.xcoord())/4,
			      (uno.ycoord()+dos.ycoord()+tres.ycoord()+quatro.ycoord())/4,
			      (uno.zcoord()+dos.zcoord()+tres.zcoord()+quatro.zcoord())/4));
}

// class D3Graph
D3Graph::D3Graph(void)
{
  initialize();
  return;
}

D3Graph::D3Graph(MyNode* list)
{
  initialize();
  initialize(list);
  return;
}

D3Graph::D3Graph(MyGraph* G)
{
  initialize();
  initialize(G);
  return;
}

D3Graph::D3Graph(MyNode* list, MyGraph* G)
{
  initialize();
  initialize(list);
  initialize(G);
  return;
}

D3Graph::D3Graph(MyGraph* G, MyNode* list)
{
  initialize();
  initialize(list);
  initialize(G);
  return;
}

D3Graph::~D3Graph(void)
{
  remove();
}

void D3Graph::initialize(void)
{
  knot   = NULL;
  master = NULL;
  area   = NULL;
  cake   = NULL;
  space  = NULL;

  NEIGHBOR = NULL;
  ALL = NULL;

  subdivision_time = 0;

  return;
}

void D3Graph::initialize(MyNode* list)
{
  MyNode* tp;
  MyNode* kp;

  kp = knot = new MyNode(list->node);
  kp->upper = list->upper;
  tp = list->next;
  while (tp != NULL) {
    kp = knot->append(tp->node);
    kp->upper = tp->upper;
    tp = tp->next;
  }

  return;
}

void D3Graph::initialize(MyGraph* G)
{
  master = G;
  return;
}

void D3Graph::initialize(MyNode* list, MyGraph* G)
{
  initialize();
  initialize(list);
  initialize(G);
  return;
}

void D3Graph::initialize(MyGraph* G, MyNode* list)
{
  initialize();
  initialize(list);
  initialize(G);
  return;
}

void D3Graph::remove(void)
{
  return;
}

Pillar* D3Graph::get_pillars(void)
{
  MyNode* tmp;
  Pillar* pp;

  MyNode* a;
  MyNode* b;
  MyNode* c;

  D3MyNode* t;

  double x_min, x_max, y_min, y_max, height;

  if (master == NULL) {
    return NULL;
  }

  if (cake != NULL) {
    return cake;
  }

  tmp = master->get_polygons();

  //  cout << "tmp = " << tmp << endl;
  //  cout << "tmp->before = " << tmp->before << endl;
  //  ::W.read_mouse();

  while (tmp != NULL) {
    a = tmp;
    tmp = tmp->next;
    b = tmp;
    tmp = tmp->next;
    c = tmp;
    tmp = tmp->next;

    //    ::W.clear();
    //    ::W.set_color(color(0x00, 0x80, 0x00));
    //    ::W.draw_segment(segment(b->node, c->node));
    //    ::W.draw_segment(segment(c->node, a->node));
    //    ::W.draw_segment(segment(a->node, b->node));
    //    ::W.set_color(color(0xFF, 0x00, 0x00));
    //    ::W.draw_point(a->node);
    //    ::W.draw_point(b->node);
    //    ::W.draw_point(c->node);
    //    ::W.read_mouse();

    //    cout << a << " " << b << " " << c << endl;

    if (cake == NULL) {
      pp = cake = new Pillar(a, b, c);
      x_min = x_max = pp->ceiling->a->node.xcoord();
      y_min = y_max = pp->ceiling->a->node.ycoord();
    } else {
      pp = cake->append(a, b, c);
      if (pp->ceiling->a->node.xcoord() < x_min)
	x_min = pp->ceiling->a->node.xcoord();
      if (pp->ceiling->a->node.xcoord() > x_max)
	x_max = pp->ceiling->a->node.xcoord();
      if (pp->ceiling->a->node.ycoord() < y_min)
	y_min = pp->ceiling->a->node.ycoord();
      if (pp->ceiling->a->node.ycoord() > y_max)
	y_max = pp->ceiling->a->node.ycoord();
    }
    if (pp->ceiling->b->node.xcoord() < x_min)
      x_min = pp->ceiling->b->node.xcoord();
    if (pp->ceiling->b->node.xcoord() > x_max)
      x_max = pp->ceiling->b->node.xcoord();
    if (pp->ceiling->b->node.ycoord() < y_min)
      y_min = pp->ceiling->b->node.ycoord();
    if (pp->ceiling->b->node.ycoord() > y_max)
      y_max = pp->ceiling->b->node.ycoord();
    if (pp->ceiling->c->node.xcoord() < x_min)
      x_min = pp->ceiling->c->node.xcoord();
    if (pp->ceiling->c->node.xcoord() > x_max)
      x_max = pp->ceiling->c->node.xcoord();
    if (pp->ceiling->c->node.ycoord() < y_min)
      y_min = pp->ceiling->c->node.ycoord();
    if (pp->ceiling->c->node.ycoord() > y_max)
      y_max = pp->ceiling->c->node.ycoord();
    //    cout << "Pillar was got..." << endl;
    //    pp->convert();
    //    cout << "convert complete" << endl;
    pp->switching(knot);
    //    cout << "switching complete" << endl;
    //    cout << "getting pillar..." << endl;
  } 

  height = (x_max-x_min+y_max-y_min) / weight;

  pp = cake;
  while (pp != NULL) {
    t = pp->ceiling->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ceiling->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ceiling->c;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->floor->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->floor->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->floor->c;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->bc_wall->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->bc_wall->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->bc_wall->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->bc_wall->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->bc_wall->next->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->bc_wall->next->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->bc_wall->next->next->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->bc_wall->next->next->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ca_wall->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ca_wall->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ca_wall->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ca_wall->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ca_wall->next->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ca_wall->next->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ca_wall->next->next->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ca_wall->next->next->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ab_wall->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ab_wall->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ab_wall->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ab_wall->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ab_wall->next->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    t = pp->ab_wall->next->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ab_wall->next->next->next->a;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), (-1) * height);
    t = pp->ab_wall->next->next->next->b;
    t->node = d3_point(t->node.xcoord(), t->node.ycoord(), height);
    pp = pp->next;
  }

  //  ::W.read_mouse();

  return cake;
}

Tetrahedral* D3Graph::get_tetrahedral(void)
{
  Pillar* pp;
  Tetrahedral* tp;

  d3_point a, b, c, d, t;

  if (cake == NULL) {
    cake = get_pillars();
    if (cake == NULL)
      return NULL;
  }

  if (space != NULL) {
    return space;
  }

  pp = cake;
  while (pp != NULL) {
    if (space == NULL)
      space = pp->get_parts();
    else
      space->append(pp->get_parts());
    pp = pp->next;
  }

  /*
  tp = space;
  while (tp != NULL) {
    a = tp->a->a->node;
    b = tp->a->b->node;
    c = tp->a->c->node;
    d = d3_point(0, 0, 0);
    t = tp->b->a->node;
    if (t != a && t != b && t != c)
      d = t;
    t = tp->b->b->node;
    if (t != a && t != b && t != c)
      d = t;
    t = tp->b->c->node;
    if (t != a && t != b && t != c)
      d = t;

    cout << a << b << c << d << endl;

    tp = tp->next;
  }
  */

  return space;
}

Tetrahedral* D3Graph::subdivision(void)
{
  Tetrahedral* time;
  Tetrahedral* tp;

  subdivision_time++;

  time = NULL;
  tp   = space;
  while (tp != NULL) {
    if (tp->a->a->in_knot || tp->a->b->in_knot || tp->a->c->in_knot ||
	tp->b->a->in_knot || tp->b->b->in_knot || tp->b->c->in_knot ||
	tp->c->a->in_knot || tp->c->b->in_knot || tp->c->c->in_knot ||
	tp->d->a->in_knot || tp->d->b->in_knot || tp->d->c->in_knot) {
      if (time == NULL)
	time = tp->subdivision();
      else
	time->append(tp->subdivision());
    }
    tp = tp->next;
  }

  while (space->next != NULL) 
    delete space->next;
  delete space;

  space = time;

  return space;
}

GRAPH<d3_point, int>* D3Graph::construct_space(void)
{
  Tetrahedral* tp;

  d3_point p[7];
  node tn[5];
  edge te[4][4];
  edge ec;
  int i, j;

  if (ALL == NULL)
    ALL = new GRAPH<d3_point, int>;

  ALL->clear();

  if (space == NULL)
    get_tetrahedral();

  //  cout << "check point" << endl;

  tp = space;
  while (tp != NULL) {
    p[0] = tp->a->a->node;
    p[1] = tp->a->b->node;
    p[2] = tp->a->c->node;
    p[4] = tp->b->a->node;
    p[5] = tp->b->b->node;
    p[6] = tp->b->c->node;
    //    for (i = 0; i < 7; i++)
    //      cout << p[i];
    //    cout << endl;
    if (p[4] != p[0] && p[4] != p[1] && p[4] != p[2]) {
      p[3] = p[4];
    }
    if (p[5] != p[0] && p[5] != p[1] && p[5] != p[2]) {
      p[3] = p[5];
    }
    if (p[6] != p[0] && p[6] != p[1] && p[6] != p[2]) {
      p[3] = p[6];
    }

    tn[0] = nil;
    tn[1] = nil;
    tn[2] = nil;
    tn[3] = nil;
    tn[4] = ALL->first_node();

    while(tn[4] != nil && (tn[0] == nil || tn[1] == nil || tn[2] == nil || tn[3] == nil)) {
      if (ALL->inf(tn[4]) == p[0])
	tn[0] = tn[4];
      if (ALL->inf(tn[4]) == p[1])
	tn[1] = tn[4];
      if (ALL->inf(tn[4]) == p[2])
	tn[2] = tn[4];
      if (ALL->inf(tn[4]) == p[3])
	tn[3] = tn[4];
      tn[4] = ALL->succ_node(tn[4]);
    }

    if (tn[0] == nil)
      tn[0] = ALL->new_node(p[0]);
    if (tn[1] == nil)
      tn[1] = ALL->new_node(p[1]);
    if (tn[2] == nil)
      tn[2] = ALL->new_node(p[2]);
    if (tn[3] == nil)
      tn[3] = ALL->new_node(p[3]);

    for (i = 0; i < 4; i++) {
      for (j = 0; j < 4; j++) {
	te[i][j] = nil;
      }
    }

    ec = ALL->first_edge();

    while (ec != nil && (te[0][1] == nil || te[0][2] == nil || te[0][3] == nil || te[1][2] == nil || te[1][3] == nil || te[2][3] == nil)) {
      if ((source(ec) == tn[0] && target(ec) == tn[1]) || (source(ec) == tn[1] && target(ec) == tn[0]))
	te[0][1] = ec;
      if ((source(ec) == tn[0] && target(ec) == tn[2]) || (source(ec) == tn[2] && target(ec) == tn[0]))
	te[0][2] = ec;
      if ((source(ec) == tn[0] && target(ec) == tn[3]) || (source(ec) == tn[3] && target(ec) == tn[0]))
	te[0][3] = ec;
      if ((source(ec) == tn[1] && target(ec) == tn[2]) || (source(ec) == tn[2] && target(ec) == tn[1]))
	te[1][2] = ec;
      if ((source(ec) == tn[1] && target(ec) == tn[3]) || (source(ec) == tn[3] && target(ec) == tn[1]))
	te[1][3] = ec;
      if ((source(ec) == tn[2] && target(ec) == tn[3]) || (source(ec) == tn[3] && target(ec) == tn[2]))
	te[2][3] = ec;
      ec = ALL->succ_edge(ec);
    }

    if (te[0][1] == nil)
      ALL->new_edge(tn[0], tn[1]);
    if (te[0][2] == nil)
      ALL->new_edge(tn[0], tn[2]);
    if (te[0][3] == nil)
      ALL->new_edge(tn[0], tn[3]);
    if (te[1][2] == nil)
      ALL->new_edge(tn[1], tn[2]);
    if (te[1][3] == nil)
      ALL->new_edge(tn[1], tn[3]);
    if (te[2][3] == nil)
      ALL->new_edge(tn[2], tn[3]);

    tp = tp->next;
  }

  return ALL;
}

GRAPH<d3_point, int>* D3Graph::construct_neighborhood(void)
{
  Tetrahedral* tp;

  d3_point p[7];
  bool t[4][4];
  bool tmp;
  node tn[5];
  edge te[4][4];
  edge ec;
  int i, j;

  node v;
  list<d3_point> l;

  if (ALL == NULL) {
    construct_space();
  }

  while(subdivision_time < 2) {
    subdivision();
  }

  if (NEIGHBOR == NULL)
    NEIGHBOR = new GRAPH<d3_point, int>;

  NEIGHBOR->clear();

  if (space == NULL)
    get_tetrahedral();

  //  cout << "check point" << endl;

  tp = space;
  while (tp != NULL) {
    //    cout << "check 1" << endl;
    if (tp->a->a->in_knot  || tp->a->b->in_knot  || tp->a->c->in_knot ||
	tp->b->a->in_knot  || tp->b->b->in_knot  || tp->b->c->in_knot ||
	tp->c->a->in_knot  || tp->c->b->in_knot  || tp->c->c->in_knot ||
	tp->d->a->in_knot  || tp->d->b->in_knot  || tp->d->c->in_knot) {
      /*
	if (is_the_node_in_the_knot_from_all(tp->a->a->node) ||
	  is_the_node_in_the_knot_from_all(tp->a->b->node) ||
	  is_the_node_in_the_knot_from_all(tp->a->c->node) ||
	  is_the_node_in_the_knot_from_all(tp->b->a->node) ||
	  is_the_node_in_the_knot_from_all(tp->b->b->node) ||
	  is_the_node_in_the_knot_from_all(tp->b->c->node) ||
	  is_the_node_in_the_knot_from_all(tp->c->a->node) ||
	  is_the_node_in_the_knot_from_all(tp->c->b->node) ||
	  is_the_node_in_the_knot_from_all(tp->c->c->node) ||
	  is_the_node_in_the_knot_from_all(tp->d->a->node) ||
	  is_the_node_in_the_knot_from_all(tp->d->b->node) ||
	  is_the_node_in_the_knot_from_all(tp->d->c->node)) {
      */
      p[0] = tp->a->a->node;
      p[1] = tp->a->b->node;
      p[2] = tp->a->c->node;
      t[0][1] = t[1][0] = !tp->a->a->in_knot && !tp->a->b->in_knot;
      t[0][2] = t[2][0] = !tp->a->a->in_knot && !tp->a->c->in_knot;
      t[1][2] = t[2][1] = !tp->a->b->in_knot && !tp->a->c->in_knot;
      p[4] = tp->b->a->node;
      p[5] = tp->b->b->node;
      p[6] = tp->b->c->node;
      //    for (i = 0; i < 7; i++)
      //      cout << p[i];
      //    cout << endl;
      if (p[4] != p[0] && p[4] != p[1] && p[4] != p[2]) {
	p[3] = p[4];
	tmp = tp->b->a->in_knot;
      }
      if (p[5] != p[0] && p[5] != p[1] && p[5] != p[2]) {
	p[3] = p[5];
	tmp = tp->b->b->in_knot;
      }
      if (p[6] != p[0] && p[6] != p[1] && p[6] != p[2]) {
	p[3] = p[6];
	tmp = tp->b->c->in_knot;
      }
      t[0][3] = t[3][0] = !tp->a->a->in_knot && !tmp;
      t[1][3] = t[3][1] = !tp->a->b->in_knot && !tmp;
      t[2][3] = t[3][2] = !tp->a->c->in_knot && !tmp;

      tn[0] = nil;
      tn[1] = nil;
      tn[2] = nil;
      tn[3] = nil;
      tn[4] = NEIGHBOR->first_node();

      //      cout << "check 2" << endl;

      while(tn[4] != nil && (tn[0] == nil || tn[1] == nil || tn[2] == nil || tn[3] == nil)) {
	if (ALL->inf(tn[4]) == p[0])
	  tn[0] = tn[4];
	if (ALL->inf(tn[4]) == p[1])
	  tn[1] = tn[4];
	if (ALL->inf(tn[4]) == p[2])
	  tn[2] = tn[4];
	if (ALL->inf(tn[4]) == p[3])
	  tn[3] = tn[4];
	tn[4] = NEIGHBOR->succ_node(tn[4]);
      }

      //      cout << "check 3" << endl;

      if (tn[0] == nil && (t[0][1] || t[0][2] || t[0][3]))
	tn[0] = NEIGHBOR->new_node(p[0]);
      if (tn[1] == nil && (t[1][0] || t[1][2] || t[1][3]))
	tn[1] = NEIGHBOR->new_node(p[1]);
      if (tn[2] == nil && (t[2][0] || t[2][1] || t[2][3]))
	tn[2] = NEIGHBOR->new_node(p[2]);
      if (tn[3] == nil && (t[3][0] || t[3][1] || t[3][2]))
	tn[3] = NEIGHBOR->new_node(p[3]);

      //      cout << "check 4" << endl;

      for (i = 0; i < 4; i++) {
	for (j = 0; j < 4; j++) {
	  te[i][j] = nil;
	}
      }

      ec = NEIGHBOR->first_edge();
      
      while(ec != nil && (te[0][1] == nil || te[0][2] == nil || te[0][3] == nil || te[1][2] == nil || te[1][3] == nil || te[2][3] == nil)) {
	if (t[0][1] && ((source(ec) == tn[0] && target(ec) == tn[1]) || (source(ec) == tn[1] && target(ec) == tn[0])))
	  te[0][1] = ec;
	if (t[0][2] && ((source(ec) == tn[0] && target(ec) == tn[2]) || (source(ec) == tn[2] && target(ec) == tn[0])))
	  te[0][2] = ec;
	if (t[0][3] && ((source(ec) == tn[0] && target(ec) == tn[3]) || (source(ec) == tn[3] && target(ec) == tn[0])))
	  te[0][3] = ec;
	if (t[1][2] && ((source(ec) == tn[1] && target(ec) == tn[2]) || (source(ec) == tn[2] && target(ec) == tn[1])))
	  te[1][2] = ec;
	if (t[1][3] && ((source(ec) == tn[1] && target(ec) == tn[3]) || (source(ec) == tn[3] && target(ec) == tn[1])))
	  te[1][3] = ec;
	if (t[2][3] && ((source(ec) == tn[2] && target(ec) == tn[3]) || (source(ec) == tn[3] && target(ec) == tn[2])))
	  te[2][3] = ec;
	ec = NEIGHBOR->succ_edge(ec);
      }

      //      cout << "check 5" << endl;

      if (te[0][1] == nil && t[0][1])
	NEIGHBOR->new_edge(tn[0], tn[1]);
      if (te[0][2] == nil && t[0][2])
	NEIGHBOR->new_edge(tn[0], tn[2]);
      if (te[0][3] == nil && t[0][3])
	NEIGHBOR->new_edge(tn[0], tn[3]);
      if (te[1][2] == nil && t[1][2])
	NEIGHBOR->new_edge(tn[1], tn[2]);
      if (te[1][3] == nil && t[1][3])
	NEIGHBOR->new_edge(tn[1], tn[3]);
      if (te[2][3] == nil && t[2][3])
	NEIGHBOR->new_edge(tn[2], tn[3]);

      //      cout << "check 6" << endl;
    }

    //    cout << "check 7" << endl;

    tp = tp->next;
  }

  /*
  forall_nodes(v, *NEIGHBOR) {
    l.append(NEIGHBOR->inf(v));
  }

  C_HULL = new GRAPH<d3_point, int>;

  CONVEX_HULL(l, *C_HULL);
  */

  //  cout << "check 8" << endl;

  return NEIGHBOR;
}

bool D3Graph::is_the_node_in_the_knot_from_all(node v)
{
  d3_point p;
  Tetrahedral* tp;

  p = ALL->inf(v);
  if (space == NULL)
    return false;
  tp = space;
  while (tp != NULL) {
    if (p == tp->a->a->node && tp->a->a->in_knot)
      return true;
    if (p == tp->a->b->node && tp->a->b->in_knot)
      return true;
    if (p == tp->a->c->node && tp->a->c->in_knot)
      return true;
    if (p == tp->b->a->node && tp->b->a->in_knot)
      return true;
    if (p == tp->b->b->node && tp->b->b->in_knot)
      return true;
    if (p == tp->b->c->node && tp->b->c->in_knot)
      return true;
    if (p == tp->c->a->node && tp->c->a->in_knot)
      return true;
    if (p == tp->c->b->node && tp->c->b->in_knot)
      return true;
    if (p == tp->c->c->node && tp->c->c->in_knot)
      return true;
    if (p == tp->d->a->node && tp->d->a->in_knot)
      return true;
    if (p == tp->d->b->node && tp->d->b->in_knot)
      return true;
    if (p == tp->d->c->node && tp->d->c->in_knot)
      return true;
    tp = tp->next;
  }

  return false;
}

bool D3Graph::is_the_node_in_the_knot_from_all(d3_point p)
{
  Tetrahedral* tp;

  if (space == NULL)
    return false;
  tp = space;
  while (tp != NULL) {
    if (p == tp->a->a->node && tp->a->a->in_knot)
      return true;
    if (p == tp->a->b->node && tp->a->b->in_knot)
      return true;
    if (p == tp->a->c->node && tp->a->c->in_knot)
      return true;
    if (p == tp->b->a->node && tp->b->a->in_knot)
      return true;
    if (p == tp->b->b->node && tp->b->b->in_knot)
      return true;
    if (p == tp->b->c->node && tp->b->c->in_knot)
      return true;
    if (p == tp->c->a->node && tp->c->a->in_knot)
      return true;
    if (p == tp->c->b->node && tp->c->b->in_knot)
      return true;
    if (p == tp->c->c->node && tp->c->c->in_knot)
      return true;
    if (p == tp->d->a->node && tp->d->a->in_knot)
      return true;
    if (p == tp->d->b->node && tp->d->b->in_knot)
      return true;
    if (p == tp->d->c->node && tp->d->c->in_knot)
      return true;
    tp = tp->next;
  }

  return false;
}

bool D3Graph::is_the_edge_in_the_knot_from_all(edge e)
{
  d3_point s;
  d3_point t;
  Tetrahedral* tp;

  s = ALL->inf(source(e));
  t = ALL->inf(target(e));
  if (space == NULL)
    return false;

  tp = space;
  while (tp != NULL) {
    if ((d3_segment(s, t) == tp->a->bc->arc || d3_segment(t, s) == tp->a->bc->arc) && tp->a->bc->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->a->ca->arc || d3_segment(t, s) == tp->a->ca->arc) && tp->a->ca->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->a->ab->arc || d3_segment(t, s) == tp->a->ab->arc) && tp->a->ab->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->b->bc->arc || d3_segment(t, s) == tp->b->bc->arc) && tp->b->bc->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->b->ca->arc || d3_segment(t, s) == tp->b->ca->arc) && tp->b->ca->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->b->ab->arc || d3_segment(t, s) == tp->b->ab->arc) && tp->b->ab->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->c->bc->arc || d3_segment(t, s) == tp->c->bc->arc) && tp->c->bc->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->c->ca->arc || d3_segment(t, s) == tp->c->ca->arc) && tp->c->ca->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->c->ab->arc || d3_segment(t, s) == tp->c->ab->arc) && tp->c->ab->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->d->bc->arc || d3_segment(t, s) == tp->d->bc->arc) && tp->d->bc->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->d->ca->arc || d3_segment(t, s) == tp->d->ca->arc) && tp->d->ca->in_knot)
      return true;
    if ((d3_segment(s, t) == tp->d->ab->arc || d3_segment(t, s) == tp->d->ab->arc) && tp->d->ab->in_knot)
      return true;

    tp = tp->next;
  }

  return false;
}

//  end
